/* Seamless3d

Copyright (C) 2001-2014 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"

//#define NARATION 1

extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;
extern const char* menu_import_bxx_av_studio;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preYouTubeTut(){
	g_robotDemo->fileName="nurbs-stitched-avatar";
	g_robotDemo->function=InputEvent::youTubeTut;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::youTubeTut(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int headEnd = 9;
	//const int l_eyeball = head+1;
	//const int r_eyeball = l_eyeball+1;

	const int l_collar = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;
	int l_wrist = 13;
	const int l_handEnd = 14;

	const int r_collar = 15;
	const int r_shoulder = 16;
	int r_elbow = 17;
	int r_wrist =	18;
	const int r_handEnd = 19;

	const int l_hip = 20;
	int l_knee = 21;
	int l_ankle = 22;
	const int l_footEnd = 23;

	const int r_hip = 24;
	int r_knee = 25;
	int r_ankle = 26;
	const int r_footEnd = 27;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		
		new Section("Create a new seamless file"),

		//new ResizeSceneTreeWin(330, 643),
		new ClickButton(fileMenu),
		new Move_MenuItem("new     (Ctrl N)"),
		new Click,
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\create-new-file.wav"),
#endif
new Section("Add boxes"),
new ClickButton(setBirdsEyeViewOrientation),

new ClickButton(buildBoxForSelPart),

new AddCtrlPnt(-1,0),
new AddCtrlPnt(-.75,-.15),
new DragViewRot(.992498,.106376,-.06026,.74739, -.734375,-.165625),
new AddCtrlPnt(-.73125,.01875),
new ClickButton(convertToPatch),

new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new IncFieldX("control_z_staves"),
new IncFieldX("control_z_staves"),
new ToggleField("done"),

new Section("Delete patches"),
new DemoMove(-.709375,.034375),
new DemoMove(-.70625,.103125),


new TugCP(58,-.741825,.064882),
new ClickButton(moreModellingMenu),
new Move_MenuItem("delete selected patches"),
new Click,

new Section("Extrude thumb"),
new TugCP(14,-.920124,-.034164),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("insertions"),
new IncFieldX("distance",55),
new ToggleField("done"),

new Section("Extrude middle finger"),
new TugCP(34,-1.239834,.071294),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("insertions"),
new IncFieldX("distance",61),
new ClickButton(setBirdsEyeViewOrientation),
new ToggleField("done"),

new ClickButton(selectRing),

new SelNurbsLine(254,255,.787712),

new Scale1d(0,-1.385826,-.000038),
new TugCP(252,-1.256146,-.050038),

new Section("Extrude index finger"),
new TugCP(28,-1.249999,-.100002),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("insertions"),
new IncFieldX("distance",59),
new ToggleField("done"),

new Section("Refine index finger"),

new ClickButton(toggleBackfaceSelect),
new RectVert(-1.79375,-.1125,-1.2625,-.38125),
new Neutral(1,-1.76771,.351042),
new Scale1d(1,-1.945075,.73275),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-1.239581,-.105208,0)),
new Rotate(0,-.704167,-.035417),
new ClickButton(selectRing),
new SelNurbsLine(286,287,.684089),
new TugCP(288,-1.238859,-.154099),


new Section("Extrude pinky"),

new TugCP(28,-1.249999,.099998),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("insertions"),
new IncFieldX("distance",52),
new ToggleField("done"),

new Section("Reangle fingers"),


new RectVert(-1.715625,.340625,-1.286458,.094792),
new Neutral(1,-1.25104,.683333),
new Scale1d(1,-1.158944,.883869),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-1.25729,.117708,0)),
new Rotate(0,-.798958,.085417),
new ClickButton(selectRing),
new SelNurbsLine(322,323,.753566),
new TugCP(324,-1.254777,.066141),



new RectVert(-1.221875,-.209375,-.648958,-.663542),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.934375,-.160417,0)),
new Rotate(0,-.575,-.470833),
new TugCP(17,-1.095834,-.187501),
new TugCP(15,-1.179167,-.158334),
new TugCP(193,-1.114577,-.257249),
new TugCP(189,-.91998,-.251459),

new Section("Form wrist"),
new ClickButton(selectRing),

new SelNurbsLine(150,159,.1),


new TugCP(159,-.535417,-.100001),

new Scale1d(1,-.5354,.382381),


new ClickButton(insertControlPoint),

new SelNurbsLine(85,86,.360853),
new ToggleField("done"),
new ClickButton(selectRing),

new SelNurbsLine(174,185,.4),

new Scale1d(1,-.712508,.375113),

new ClickButton(selectRing),

new SelNurbsLine(187,176,.1),

new Scale1d(1,-.812499,.453404),


new Section("Flatten palms"),
new ClickButton(setFrontViewOrientation),

new RectVert(-1.246875,.23125,-.646874,.129167),
new TugCP(198,-.808334,.125088),
new RectVert(-1.25,.01875,-.689582,-.075),
new TugCP(125,-.8125,.033333),
new RectVert(-1.828125,.38125,-.334375,-.104167),

new Scale1d(1,-1.073121,.733391),
new DragViewRot(.228805,.963848,-.136547,1.182921, -1.015625,.73125),
new ClickButton(setHomeMode),

new DragViewRot(-.721917,-.313106,-.617091,.714097, -1.4125,.984375),
new DragViewRot(-.354734,-.897384,-.262424,1.677706, -1.4125,.984375),

new ClickButton(openGridControl),

new ToggleField("show"),
new MoveToExitWindow(),
new Click(),
//new DragViewRot(.975423,.134084,-.174845,.514623, -.965625,.946875),
//new ClickButton(quantiseViewOrientation),

new DragViewRot(.998798,.031848,.037266,1.60213, -.05625,.98125),
new ClickButton(quantiseViewOrientation),

new Section("Widen hand"),
new ClickButton(setModellingMode),

new RectVert(-1.88125,.346875,-.3125,-.211458),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-1.072917,-.158333,0)),

new Scale1d(1,-1.072917,.440776),


new Section("Drop thumb"),
new RectVert(-1.321875,-.234375,-.740624,-.528125),
new ClickButton(setRightViewOrientation),


new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.123958,.073958,0)),

new Rotate(1,.342708,.358333),
new DragViewRot(.334676,.906175,.258533,1.557317),
new ClickButton(setHomeMode),

new DragViewRot(.500237,-.84636,.18286,.924269),
new ClickButton(setModellingMode),

new ClickButton(toggleBackfaceSelect),

new ClickButton(insertControlPoint),

new SelNurbsLine(222,231,.033147),
new ToggleField("done"),
new TugCP(231,-.817891,.040998),
new DragViewRot(.837805,-.535142,-.108194,1.268981),
new TugCP(23,-.997251,.365417),
new TugCP(233,-.986341,.32999),
new TugCP(247,-.902405,.178731),

new Section("Insert rings into fingers"),

new ClickButton(insertControlPoint),
new SelNurbsLine(339,348,.98438),
new ToggleField("done"),

new ClickButton(insertControlPoint),
new SelNurbsLine(312, 312 - 9,.958155),
new ToggleField("done"),

new ClickButton(insertControlPoint),
new SelNurbsLine(429,438,.009333),
new ToggleField("done"),

new ClickButton(insertControlPoint),
new SelNurbsLine(258,267,.026316),
new ToggleField("done"),

new TugCP(287,-1.177637,.174611),
new DragViewRot(.980602,.152211,-.123495,1.383346,-1.177637,.174611),
//new TugCP(283,-1.137239,-.455115),
new TugCP(287,-1.181378,-.374755),
new TugCP(350,-1.625962,.117851),
new TugCP(346,-1.61985,-.011921),
new TugCP(348,-1.62235,.048485),


new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
//new AddCtrlPnt(.418654,.522792),