/* Seamless3d

Copyright (C) 2001-2013 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;
extern const char* menu_import_bxx_av_studio;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preNurbsLatheAvDemo(){
	g_robotDemo->fileName="nurbs-stitched-avatar";
	g_robotDemo->function=InputEvent::nurbsLatheAvDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::nurbsLatheAvDemo(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int headEnd = 9;
	//const int l_eyeball = head+1;
	//const int r_eyeball = l_eyeball+1;

	const int l_collar = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;
	int l_wrist = 13;
	const int l_handEnd = 14;

	const int r_collar = 15;
	const int r_shoulder = 16;
	int r_elbow = 17;
	int r_wrist =	18;
	const int r_handEnd = 19;

	const int l_hip = 20;
	int l_knee = 21;
	int l_ankle = 22;
	const int l_footEnd = 23;

	const int r_hip = 24;
	int r_knee = 25;
	int r_ankle = 26;
	const int r_footEnd = 27;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		
		new Section("Create a new seamless file"),
		new ResizeSceneTreeWin(330, 643),
		new ClickButton(fileMenu),
		new Move_MenuItem("new     (Ctrl N)"),
		new Click,
		//new Section("Add floor & height guide"),
		//new ClickButton(floorBuild),
		//new ToggleField("zero_height"),
		new Section("Set vertical grid"),
new ClickButton(setBirdsEyeViewOrientation),
new ClickButton(buildNurbsLatheForSelPart),

new AddCtrlPnt(.003125,-.009375),
new AddCtrlPnt(-.003125,.4875),
new AddCtrlPnt(.265625,-.43125),
new AddCtrlPnt(.353125,-.459375),
//new ClickButton(setModellingMode),
new AddCtrlPnt(.446875,-.353125),
new AddCtrlPnt(.459375,-.25),
new AddCtrlPnt(.46875,-.184375),
new AddCtrlPnt(.48125,-.1),
new AddCtrlPnt(.534375,.096875),
new ToggleField("done"),
new Section("Tidy up lathe"),

new DragViewPos(.177083,0,-.064583,.546875,.090625),
new ClickControlPoint(10),
new Move3d(.369792,.433333),
new DragViewPos(.052083,0,-.222917,.55625,.4875),
new ClickControlPoint(10),
new Move3d(.423958,.325),
new DragViewPos(.10625,0,-.29375,.5125,.59375),
new ClickControlPoint(10),
new Move3d(.611458,.4875),
new ClickControlPoint(9),
new Move3d(.795833,.194792),
new ClickControlPoint(9),
new Move3d(.795833,.194792),
new ClickControlPoint(9),
new Move3d(.575,.278125),
new ClickControlPoint(7),
new Move3d(.5875,-.04375),
new DragViewPos(.077083,0,-.304167,.396875,-.003125),
new ClickControlPoint(5),
new Move3d(.690625,-.430208),
new DragViewPos(.039583,0,-.316667,.409375,-.10625),
new ClickControlPoint(3),
new Move3d(.453125,-.470833),
new DragViewRot(.560444,.358462,-.746598,.569328),
new ClickButton(convertToPatch),

new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new ClickButton(setFrontViewOrientation),

new TugCP(64,-.270372,.369391),
new TugCP(64,-.307872,.377724),
new ClickButton(extrudePatch),

new DecFieldX("distance",20),
new DecFieldX("distance"),
new DragViewRot(.239135,.067574,.968632,5.355715),
new ClickButton(setFrontViewOrientation),

new ClickButton(selectRing),

new SelNurbsLine(201,202,.762561),

new Scale1d(1,.039583,.193426),

new Scale1d(0,.940216,0),
new ClickButton(selectRing),

new SelNurbsLine(203,204,.932476),

new Scale1d(1,.039583,.200482),
new ClickButton(setRightViewOrientation),

new ClickButton(selectRing),

new SelNurbsLine(117,118,.771543),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.795833,-.580208,0)),
new DragViewPos(.039583,-.03125,-.339583,-.78125,-.075),
new DragViewPos(.039583,-.008333,-.345833,-.809375,-.115625),

new Rotate(1,-1.343751,-.498958),

new Rotate(1,-1.494792,-.822917),
new TugCP(127,-1.808818,-.587326),
new DragViewPos(.039583,.020833,-.35,-1.809375,-.575),
new DragViewPos(.039583,.041667,-.322917,-1.815625,-.54375),
new TugCP(129,-.688819,-.90506),

new Rotate(0,-.416667,.15625),
new TugCP(62,-.269792,.150232),
new DragViewRot(.061183,-.993583,-.095124,1.298552),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("distance",3),
new IncFieldX("distance"),
new IncFieldX("distance",12),
new IncFieldX("insertions"),
new DragViewPos(-.167827,.041566,.394372,.140625,.01875),
new DragViewRot(.029242,-.995741,-.087438,1.148839),
new DragViewRot(-.86023,-.477737,-.178245,.229698),

new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
//new AddCtrlPnt(.418654,.522792),