/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Complete;


void InputEvent::preMinimalistSitchedHead(){
	g_robotDemo->fileName="minimalist-stitched-head";
	g_robotDemo->function=InputEvent::minimalistSitchedHead;
	g_robotDemo->name="Open minimalist-stitched-head.smls file";
	robotDemoStart(setupSequence);
}
void InputEvent::minimalistSitchedHead(){

	const int seamless = 1;
	const int head = 3;
	const int foreheadNP = 5;

	InputEvent* create_Skeleton_of_PartsArray[]={
		new Section("Open minimalist-stitched-head.smls file"),
		new ClickButton(openSmls),
		new SetFieldValue("filename", "minimalist-stitched-head.smls"),
		new ToggleField("open"),
		new ClickYes(),
		//new Section("Drag control points"),
		//
		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0001\\sound.wav"),
		new Wait(3),
		new SelectNode(foreheadNP),
		new TugCP(1116,.652805,.624404),
		new TugCP(1103,.716616,.392169),
		new TugCP(66,.556252,.610321),
		new TugCP(367,.645732,.341994),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0002\\sound.wav"),
new DragViewRot(-.139687,-.990152,.009251,1.39349, .645732,.341994),
new DragViewRot(-.993018,-.007483,-.117727,1.502624, .645732,.341994),
new TugCP(986,.116653,.700334),
new TugCP(952,.121272,.683665),
new TugCP(988,.287938,.626522),
new TugCP(954,.254459,.582297),
new DragViewRot(-.252119,-.956547,-.146475,1.292655,.254459,.582297),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0003\\sound.wav"),
new TugCP(952,-.769344,-.199436),
new TugCP(954,-.644123,-.186605),
new DragViewRot(-.674723,.240882,.697657,2.040369,-.644123,-.186605),
new ClickButton(toggleWireFrame),

new TugCP(916,.143969,.740683),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0004\\sound.wav"),
new TugCP(914,.089507,.570293),
new ClickButton(toggleWireFrame),

new DragViewRot(-.876756,.405499,.258591,.442393),
new DragViewRot(-.998018,.062438,.007817,1.191401),
new TugCP(916,-.034319,.402167),
new DragViewRot(.127308,.901183,.414321,.679192,-.034319,.402167),
///
//new Section("Drag vertices"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0005\\sound.wav"),

new SelectNode(head),
new Wait(4),
new SelectTriangle(7085,head),
new Wait(1),
new ClickButton(toggleWireFrame),
new Wait(2),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0006\\sound.wav"),
new MouseZoom(10.834709),

new MouseZoom(19.194351),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0007\\sound.wav"),
new Wait(2),
new ClickButton(centerViewToControlPoint),

new MouseZoom(66.26413),
new DragViewRot(-.992422,-.080612,-.092738,.389944),

//new Section("Drag vertices2"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0008\\sound.wav"),
new TugVertex(1883,.67385,-.606308,head),
new TugVertex(1874,.615335,-.856264,head),
new TugVertex(1120,-.418946,-.325963,head),
new TugVertex(1231,.048934,-.306908,head),
new TugVertex(1230,.540817,-.238826,head),
new TugVertex(1251,.896836,-.077343,head),

new TugVertex(1220,.066424,-.377008,head),
new TugVertex(1886,.073709,-.483817,head),
new ClickButton(toggleWireFrame),
new Wait(1),
new ClickButton(toggleWireFrame),
new Wait(4),

new TugVertex(1886,.062108,-.411669,head),
new TugVertex(1220,.063141,-.411377,head),
new ClickButton(toggleWireFrame),
new Wait(1),
new ClickButton(toggleWireFrame),

new TugVertex(1242,.023701,-.210888,head),
new TugVertex(1242,-.001206,-.109363,head),
new Wait(2),
//new TugVertex(1242,.018469,-.170942,head),
new TugVertex(1241,.013735,-.166467,head),
new Wait(1),
//		new Section("Color vertices"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0009\\sound.wav"),
new Wait(3),
new ClickButton(openPalette),
new SelectVertex(1884,head),
new TypeString("r"),
new SelectVertex(1120,head),
new TypeString("c"),
new SelectVertex(1231,head),
new TypeString("c"),
new SelectVertex(1230,head),
new TypeString("c"),
new SelectVertex(1251,head),
new TypeString("c"),
new SelectVertex(1241,head),
new TypeString("c"),
new Wait(2),
//new Section("Color all"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0010\\sound.wav"),
new SelectTriangle(7305,head),
new ClickColorCell(2, 0), //blue
new VirtKeyDown(VK_LCONTROL),
new Wait(2),
new TypeString("h"),
new VirtKeyUp(VK_LCONTROL),
new ClickButton(toggleWireFrame),
//new Section("Pull lips out"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0011\\sound.wav"),
new MouseZoom(30.912699),
new DragViewRot(-.156435,-.975492,-.154736,1.319669),
new SelectNode(foreheadNP),

new TugCP(693,-.289243,.102931),
new TugCP(676,-.259352,-.007602),
new TugCP(687,-.299982,.201058),
new TugCP(684,-.191498,.335542),
new DragViewRot(-.563474,.653542,.505351,1.770378,-.191498,.335542),
new TugCP(676,.018527,-.008837),
new DragViewRot(-.598535,-.801015,-.011475,1.106391,.018527,-.008837),
new TugCP(661,.085274,-.145151),


//new Section("end off"),

new MouseZoom(7.400251),
new DragViewRot(-.903496,-.428252,.017196,.320545,.085274,-.145151),
new TugCP(557,.590246,.180272),
new TugCP(1090,.693408,.131472),
new TugCP(763,.484847,-.030832),
new TugCP(1077,.615957,-.052089),
new TugCP(924,.412154,-.212343),
new TugCP(1064,.536842,-.210971),
new TugCP(1092,.714252,.137122),
new TugCP(1079,.640477,-.038175),
new TugCP(1066,.515674,-.180569),
new TugCP(1051,.466269,-.337728),
new TugCP(1064,.451842,-.200971),

new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
