/* Seamless3d

Copyright (C) 2001-2012 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Complete;
extern const char* Setup_Animation;
extern const char* dt_Build_a_Cone;
extern const char* dt_Set_Second_Pose;
extern const char* dt_Copy_First_Pose_and_Paste_to_Last_Pose;
extern const char* dt_Move_cones_pivot_point_Up;
extern const char* dt_Move_cone_as_a_Child_of_cylinder;
extern const char* Animate_Position;
extern const char* dt_Create_a_Bxx_Av_PROTO_by_Adding_a_GestureGroup;
extern const char* dt_Animate_cylinder;
extern const char* dt_Set_First_Pose;
extern const char* dt_Build_a_Cylinder;
extern const char* dt_Move_cone_Up;

extern const char* str_hello="hello";
void toggleSelectObject();


void InputEvent::preBeelineAnimDemo(){
	g_robotDemo->fileName="beeline-anim";
	g_robotDemo->function=InputEvent::beelineAnimDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::beelineAnimDemo(){
	const int scene=0;
	const int seamless=1;
	const int part1=seamless+2;
	int coneBuild=part1+1;
	int anim=coneBuild+2;

InputEvent* eventArray[]={
	new Section(Create_a_New_Seamless_File),
	//new TypeString(deleteOldFileAndCreateFileName());
	new ClickButton(newSmls),
	new SetFieldValue("filename", "beeline-anim.smls"),
	new ToggleField("save"),
	new ClickYes(),
	//new ClickButton(openSceneTree),
	//new ClickButton(toggleXRayMode),

	new Section(dt_Build_a_Cone),
	new ClickButton(buildConeForSelPart),

	new Section(Setup_Animation),
	new ClickButton(setAnimationMode),
	new Section(dt_Set_First_Pose),


/////

	//selNode(0);
	//newNodeAsChild(ANIM, scene);
//	list+=new MoveToNodeAsChild(anim);//we need to click it twice to make the carret wink if the window is made visiable for the first time
//	list+=new Click();
	//nameNode(anim, str_hello);
/*
	list+=new Section(Make_Another_Control_Panel);
	rightClickNode(anim);
	list+=new Move_MenuItem(menu_new_panel);
	list+=new Click;
	list+=new MoveToTitleBar();
	list+=new LeftButtonDown();
	list+=new Move(100,374);
	list+=new LeftButtonUp();
	list+=new MoveToTitleBar(1);
	list+=new LeftButtonDown();
	list+=new Move(100,137);
	list+=new LeftButtonUp();
*/
	//list+=new SelectNode(part1);
	new MoveToAnimRotPoint(),
	new Move3d(Vec2f(.415,.365)),
	new ToggleField("play"),
	new Wait(1.5),
	new Section(Animate_Position),
	new ClickButton(toggleXRayMode),
	//list+=new ToggleField("pause");
	new DragAnimSlider(0),
	//list+=new SelectNode(part1);
	new MoveToPivotPoint(part1),
	new Move3d(-.3, .2),
	new ToggleField("play", 0),
	new Wait(1.5),
	new Section("Add a second of time"),
	new IncFieldX("period"),
	new ToggleField("play"),
	new Wait(1.5),

	new Section(dt_Set_Second_Pose),
	new DragAnimSlider(.5),
	new MoveToAnimRotPoint(),
//	if(g_robotDemo->express){
//	list+=new Move3d(Vec2f(.415,-.15));
//	}
//	else{
	new Move3d(Vec2f(.415,-.5)),
//	}
	new ToggleField("play"),
	new Wait(1.5),

	new Section(dt_Copy_First_Pose_and_Paste_to_Last_Pose),
	//list+=new DecFieldX("slider", 24);
	new DragAnimSlider(0),
	new ToggleField("copy"),
	//list+=new IncFieldX("slider", 24);
	new DragAnimSlider(1),
	new ToggleField("paste"),
	new ToggleField("ok"),
	new ToggleField("play", 1),
	new Wait(2),
	new ToggleField("loop"),
	new ToggleField("play"),
	new ClickButton(toggleWireFrame),
	new Wait(2),


	new Section("Resume modelling"),
	new ClickButton(setModellingMode),
new IncFieldX("height",20),
new ClickButton(buildCylinderForSelPart),
new ClickButton(toggleSelectObject),
new TugCP(61,.027783,.982206),
new TugCP(116,0,.115),
new DragViewPos(0,-.345, 0, -.5, 0),
new DecFieldX("radius",20),
new ClickButton(buildTorusForSelPart),

new TugCP(192,.34641,-.345),

new Rotate(0,.545),
new TugCP(186,-.285,-.70641),
//

new ClickButton(buildTorusForSelPart),
new TugCP(309,.34641,-.345),
new Rotate(0,-.855),
new TugCP(335,.475,-.70641),


new ClickButton(setAnimationMode),
new DragViewRot(.510167,.661418,-.549778,.496018),
	new Wait(2),

new Section("Move pivot point"),
new ClickButton(setFrontViewOrientation),
//new ClickButton(setModellingMode),
new ClickButton(setXRayEditMode),
new MoveToPivotPoint(3),
new Move3d(.0, .729999),
new ToggleField("mirror"),
new MoveToPivotPoint(3),
new Move3d(.5, .729999),
new MoveToPivotPoint(3),
new Move3d(0, .729999),

new ClickButton(setAnimationMode),
new DragViewRot(.207895,-.977975,-.018564,.695911),
	new Section(Complete),
};
	list+=EVENT_LIST(eventArray);
/*
	newNodeAsChild(PART, seamless);
	list+= new NameNode(part2, "cylinder");
	list+=new ClickButton(buildCylinderForSelPart);
	coneBuild++;
	anim+=2;

	list+=new Section(dt_Move_cone_Up);
	selNode(coneBuild);
//	list+=new MoveToTitleBar(1);
//	list+=new Click;
	list+=new IncFieldY("translation", 50);
	selNode(part1);
	list+=new Section(dt_Move_cones_pivot_point_Up);
//	list+=new IncButtonY(decPivotX, 50);
	list+=new IncFieldY("pivotPoint", 50);

	list+=new Section(dt_Animate_cylinder);
	list+=new SelectNode(9);
	list+=new ToggleField("pause");
	//list+=new DecFieldX("slider", 24);
	list+=new DragAnimSlider(0);
	selNode(part2);
	list+=new MoveToAnimRotPoint();
	list+=new Move3d(Vec2f(.415,-.365));
	list+=new ToggleField("copy", 1);
	//list+=new IncFieldX("slider", 24);
	list+=new DragAnimSlider(1);
	list+=new ToggleField("paste");
	list+=new ToggleField("ok");
	//list+=new DecFieldX("slider", 12);
	list+=new DragAnimSlider(.5);
	list+=new MoveToAnimRotPoint();
	list+=new Move3d(Vec2f(.415, .5));
	//list+=new ToggleField("loop");
	list+=new ToggleField("play");
	list+=new Wait(2);

	list+=new Section(dt_Move_cone_as_a_Child_of_cylinder);
	//list+=new ToggleField("pause");
	list+=new ClickButton(setPolyEditMode);
	list+=new MoveToNodeAsChild(part1);
	list+=new LeftButtonDown();
	list+=new MoveToNodeAsChild(part2);
	list+=new LeftButtonUp();
	list+=new SelectNode(9);
	//list+=new ToggleField("pause");

	list+=new Section("Move cylinder's pivot point up half way");
	list+=new VirtKeyDown(VK_LMENU);
	list+=new IncFieldY("pivotPoint", 25);
	list+=new VirtKeyUp(VK_LMENU);
	list+=new Wait(1.5);

	list+=new Section(Animate_Position);
	list+=new ToggleField("pause", 1);
	list+=new DragAnimSlider(.25);
	//list+=new SelectNode(part1);
	list+=new MoveToPivotPoint(part1);
	list+=new Move3d(-.3, 0);
	list+=new ToggleField("play", 0);

	list+=new Section(dt_Create_a_Bxx_Av_PROTO_by_Adding_a_GestureGroup);
//	anim+=5;
//	selNode(anim);
	newNodeAsChild(GESTUREGROUP, 0);
//	list+=new MoveToNodeAsChild(anim);
//	list+=new LeftButtonDown();
//	list+=new MoveToNodeAsChild(anim+8);
//	list+=new LeftButtonUp();
	clickButton(saveSmls);
	list+=new Section(Complete);
	*/
}
