/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#define _WIN32_WINNT 0x0410

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include"robot_aid.h"


extern const char* name_pelvis;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck0;
extern const char* name_neck1;
extern const char* name_hair;
extern const char* name_mouth;
extern const char* name_torsoSurface;
extern const char* name_headSurface;
extern const char* name_palmSurface;
extern const char* name_footSurface;

extern const char* name_front_view;

extern const char* menu_delete;
extern const char* menu_paste;
extern const char* menu_replace;
extern const char* menu_import;
extern const char* menu_shape_from_file;
extern const char* menu_all_nodes_from_file;

extern const char* Create_a_New_Seamless_File;
extern const char* Complete;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;

extern const char* Import_Static_Model_Into_a_Part;
extern const char* Import_Empty_Skeleton_Of_Parts;
extern const char* Replace_ColorEffect_with_TextureEffect;
extern const char* Copy_All_of_the_Triangles_to_the_Pelvis;
extern const char* Zoom_in_View_to_l_shoulder;
extern const char* Transfer_from_pelvis_to_1st_group_for_shoulder;
extern const char* Transfer_from_pelvis_to_2nd_group_for_shoulder;
extern const char* Transfer_Vertices_from_pelvis_to_rest_of_shoulder;
extern const char* Transfer_from_pelvis_to_1st_group_for_l_elbow;
extern const char* Transfer_from_pelvis_to_2nd_group_for_l_elbow;
extern const char* Transfer_Vertices_from_pelvis_to_rest_of_l_elbow;
extern const char* Transfer_from_pelvis_to_1st_group_for_l_wrist;
extern const char* Transfer_Vertices_from_pelvis_to_rest_of_l_wrist;
extern const char* Transfer_Vertices_for_the_Right_Arm;
extern const char* Transfer_pelvis_to_1st_group_for_l_hip;
extern const char* Transfer_from_pelvis_to_2nd_group_for_l_hip;
extern const char* Transfer_Vertices_from_pelvis_to_rest_of_l_hip;
extern const char* Transfer_from_pelvis_to_1st_group_for_l_knee;
extern const char* Transfer_from_pelvis_to_2nd_group_for_l_knee;
extern const char* Transfer_Vertices_from_pelvis_to_rest_of_l_knee;
extern const char* Transfer_from_pelvis_to_1st_group_for_l_ankle;
extern const char* Transfer_Vertices_from_pelvis_to_rest_of_l_ankle;
extern const char* Transfer_Vertices_for_the_Right_Leg;
extern const char* Transfer_pelvis_to_tummy0;
extern const char* Transfer_pelvis_to_tummy1;
extern const char* Transfer_pelvis_to_thorax;
extern const char* Transfer_pelvis_to_neck0;
extern const char* Transfer_pelvis_to_neck1;
extern const char* Transfer_pelvis_to_head;



void InputEvent::preBringToLifeDemo(){
	g_robotDemo->fileName="bring_to_life";
	g_robotDemo->function=bringToLifeDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::bringToLifeDemo(){
	const int seamless=1;
	const int textureEffect=2;
	const int pelvis=3;
	const int tummy0=	pelvis+1;
	const int tummy1=	tummy0+1;
	const int thorax=	tummy1+1;
	const int neck0=	thorax+1;
	const int neck1=	neck0+1;
	const int head=		neck1+1;
	const int hair=		head+1;
	const int mouth=	hair+1;
	const int l_eyeball=	mouth+1;
	const int r_eyeball=	l_eyeball+1;

	const int l_shoulder=	r_eyeball+1;
	const int l_elbow=		l_shoulder+1;
	const int l_wrist=		l_elbow+1;

	const int r_shoulder=	l_wrist+1;
	const int r_elbow=		r_shoulder+1;
	const int r_wrist=		r_elbow+1;

	const int l_hip=		r_wrist+1;
	const int l_knee=		l_hip+1;
	const int l_ankle=		l_knee+1;
	
	const int r_hip=		l_ankle+1;
	const int r_knee=		r_hip+1;
	const int r_ankle=		r_knee+1;

	const int model_source=		r_ankle+1;
	const int creamGroup=model_source+1;
	const int copyPartToPelvis=creamGroup+1;

	const int transfer_l_shoulder=copyPartToPelvis+2+3;
	const int transfer_l_elbow=transfer_l_shoulder+3;
	const int transfer_l_wrist=transfer_l_elbow+3;

	const int transfer_r_shoulder=transfer_l_wrist+3;
	const int transfer_r_elbow=transfer_r_shoulder+3;
	const int transfer_r_wrist=transfer_r_elbow+3;

	const int blueGroup=transfer_r_wrist+3;

	const int transfer_l_hip=blueGroup+1;
	const int transfer_l_knee = transfer_l_hip+3;
	const int transfer_l_ankle = transfer_l_knee+3;

	const int transfer_r_hip = transfer_l_ankle+3;
	const int transfer_r_knee = transfer_r_hip+3;
	const int transfer_r_ankle = transfer_r_knee+3;

	const int pinkGroup=transfer_r_ankle+3;

	const int transfer_tummy0=pinkGroup+1;
	const int transfer_tummy1=transfer_tummy0+3;
	const int transfer_thorax=transfer_tummy1+3;

	const int transfer_neck0=transfer_thorax+3;
	const int transfer_neck1=transfer_neck0+3;
	const int transfer_head=transfer_neck1+3;

	const int greenGroup=transfer_head+3;

	InputEvent* eventArray[]={
		new Section("Create a new seamless file"),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "bring_to_life.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new ClickButton(openSceneTree),
		new Section(Import_Empty_Skeleton_Of_Parts),
		new MoveToNode(seamless),
		new RightClick,
		new Move_MenuItem(menu_paste),
		new Move_MenuItem(menu_replace),
		new Move_MenuItem(menu_import),
		new Move_MenuItem(menu_all_nodes_from_file),
		new Click,
		new SetFieldValue("filename", "empty_skeleton.smls"),
		new ToggleField("open"),

		new Section(Replace_ColorEffect_with_TextureEffect),
	};
	list+=EVENT_LIST(eventArray);


	
	newNodeAsReplacement(TEXTUREEFFECT, textureEffect);

	list+=new Section(Import_Static_Model_Into_a_Part);
	newNodeAsChild(IMMEDIATEPART, seamless);
	nameNode(model_source, "model_source");
	rightClickNode(model_source);
	list+=new Move_MenuItem(menu_import);
	list+=new Move_MenuItem(menu_shape_from_file);
	list+=new Click;
	list+=new SetFieldValue("filename", "static_model.wrl"),
	list+=new ToggleField("open"),
	selNode(textureEffect);
	incGroupCount("url");
	setFieldValue("url", "static_model.png");

	list+=new Section(Copy_All_of_the_Triangles_to_the_Pelvis);
	hide(model_source);
	newNodeAsChild(GROUPBUILD, seamless);
	selNode(creamGroup);
	decField("marker", 20, 2);

	newNodeAsChild(COPYPART, creamGroup);
	useNodeAsSource(model_source, copyPartToPelvis);
	useNodeAsDest(pelvis, copyPartToPelvis);

	list+=new Section(Place_the_Avatar_to_the_Floor);
	clickButton(floorBuild);
	list+=new ToggleField("blaxxun_height");

	selNode(pelvis);
	clickButton(placeForSelParts);
	decField("translation", 102, 1);
	incFieldCtrl("translation", 2, 1);
//	collapse(r_hip);
//	collapse(l_hip);
//	collapse(r_shoulder);
//	collapse(neck0);

	InputEvent* move_the_Pivot_PointsArray[]={
		new Section(Move_the_Pivot_Points),
		new SelectNode(pelvis),
		new ClickButton(toggleXRayMode),
		new ClickButton(setXRayEditMode),
		new DecFieldY("pivotPoint", 97),
		new MouseZoom(2),
		new IncFieldCtrlY("pivotPoint", 1),
		new SelectNode(tummy0),
		new IncFieldY("pivotPoint", 13),
		new IncFieldCtrlY("pivotPoint", 6),
		new SelectNode(tummy1),
		new IncFieldY("pivotPoint", 11),
		new IncFieldCtrlY("pivotPoint", 3),
		new SelectNode(thorax),
		new IncFieldY("pivotPoint", 11),
		new IncFieldCtrlY("pivotPoint", 3),
		new SelectNode(neck0),
		new IncFieldY("pivotPoint", 22),
		new IncFieldCtrlY("pivotPoint", 6),
		new SelectNode(neck1),
		new IncFieldY("pivotPoint", 4),
		new IncFieldCtrlY("pivotPoint", 8),
		new SelectNode(head),
		new IncFieldY("pivotPoint", 04),

		new SelectNode(l_shoulder),
		new IncFieldY("pivotPoint", 15),
		new IncFieldX("pivotPoint", 15),
		new ClickButton(centerViewToPivotPoint),
		new MouseZoom(3),
		new IncFieldCtrlY("pivotPoint", 6),
		new IncFieldCtrlX("pivotPoint", 3),
		new SelectNode(l_elbow),
		new IncFieldX("pivotPoint", 22),
		new ClickButton(centerViewToPivotPoint),
		new IncFieldCtrlX("pivotPoint", 5),
		new SelectNode(l_wrist),
		new IncFieldX("pivotPoint", 22),
		new ClickButton(centerViewToPivotPoint),
		new IncFieldCtrlX("pivotPoint", 7),

//		new Collapse(r_shoulder),
		//new SelectNode(r_shoulder),
		//new ClickButton(centerViewToPivotPoint),
		//new IncFieldY("pivotPoint", 15),
		//new DecFieldX("pivotPoint", 15),
		//new ClickButton(centerViewToPivotPoint),
		//new IncFieldCtrlY("pivotPoint", 6),
		//new DecFieldCtrlX("pivotPoint", 3),
		//new SelectNode(r_elbow),
		//new DecFieldX("pivotPoint", 22),
		//new ClickButton(centerViewToPivotPoint),
		//new DecFieldCtrlX("pivotPoint", 5),
		//new SelectNode(r_wrist),
		//new DecFieldX("pivotPoint", 22),
		//new ClickButton(centerViewToPivotPoint),
		//new DecFieldCtrlX("pivotPoint", 7),

//		new Collapse(l_hip),
		new SelectNode(l_hip),
		new ClickButton(centerViewToPivotPoint),
		new IncFieldX("pivotPoint", 8),
		new IncFieldCtrlX("pivotPoint", 7),
		new SelectNode(l_knee),
		new DecFieldY("pivotPoint", 33),
		new ClickButton(centerViewToPivotPoint),
		new DecFieldCtrlY("pivotPoint", 4),
		new SelectNode(l_ankle),
		new DecFieldY("pivotPoint", 33),
		new DecFieldCtrlY("pivotPoint", 4),
		new ClickButton(setXRayEditMode),

//		new Collapse(r_hip),
		//new SelectNode(r_hip),
		//new ClickButton(centerViewToPivotPoint),
		//new DecFieldX("pivotPoint", 8),
		//new DecFieldCtrlX("pivotPoint", 7),
		//new SelectNode(r_knee),
		//new DecFieldY("pivotPoint", 33),
		//new ClickButton(centerViewToPivotPoint),
		//new DecFieldCtrlY("pivotPoint", 4),
		//new SelectNode(r_ankle),
		//new DecFieldY("pivotPoint", 33),
		//new DecFieldCtrlY("pivotPoint", 4),
	};
	list+=EVENT_LIST(move_the_Pivot_PointsArray);

	list+=new Section("Transfer from pelvis to l_shoulder");
	list+=new ClickButton(openOwnership),
	collapse(r_hip);
	collapse(l_hip);
	collapse(r_shoulder);
	collapse(neck0);
	selNode(l_shoulder);
	clickButton(centerViewToPivotPoint);
	newNodeAsChild(TRANSFERBCYL, creamGroup);
	useNodeAsSource(pelvis, transfer_l_shoulder);
	useNodeAsDest(l_shoulder, transfer_l_shoulder);
	selNode(transfer_l_shoulder);
	incFieldCtrl("orientation", 1, 2);
	incField("location", 15);
	decField("location", 45, 1);
	decField("height", 50-22);
	decField("radius", 25-5);
	incFieldCtrl("radius", 2);
//	list+=new ToggleField("in");

	list+=new Section("Create groups for l_shoulder's vertices");
	decField("numOfGroups", 1);
	incField("groupingHeight", 2);

	list+=new Section("Transfer from pelvis to l_elbow");
	selNode(l_elbow);
	clickButton(centerViewToPivotPoint);
	copyNodeAsChild(transfer_l_shoulder, creamGroup);
	useNodeAsReplacement(l_elbow, transfer_l_elbow+2);
	selNode(transfer_l_elbow);
	incField("location", 37-15);
	incFieldCtrl("location", 3);
	incField("height", 1);
	incFieldCtrl("groupingHeight", 3);

	list+=new Section("Transfer from pelvis to l_wrist");
	selNode(l_wrist);
	clickButton(centerViewToPivotPoint);
	
	copyNodeAsChild(transfer_l_elbow, creamGroup);
	useNodeAsReplacement(l_wrist, transfer_l_wrist+2);
	selNode(transfer_l_wrist);
	incField("location", 60-37);
	incField("radius", 12-5);
	decField("numOfGroups", 1);
	decFieldCtrl("groupingHeight", 1);
//	list+=new ToggleField("in");

	list+=new Section(Transfer_Vertices_for_the_Right_Arm);
	collapse(l_shoulder);
	collapse(r_shoulder);
	copyNodeAsSiblingBelow(transfer_l_shoulder, transfer_l_wrist);
	useNodeAsReplacement(r_shoulder, transfer_r_shoulder+2);
	clickButton(centerViewToPivotPoint);
	selNode(transfer_r_shoulder);
	addMinus("location");
	decFieldCtrl("orientation", 2, 2);
	//list+=new ToggleField("in");

	copyNodeAsSiblingBelow(transfer_l_elbow, transfer_r_shoulder);
	useNodeAsReplacement(r_elbow, transfer_r_elbow+2);
	clickButton(centerViewToPivotPoint);
	selNode(transfer_r_elbow);
	addMinus("location");
	decFieldCtrl("orientation", 2, 2);
//	list+=new ToggleField("in");

	copyNodeAsSiblingBelow(transfer_l_wrist, transfer_r_elbow);
	useNodeAsReplacement(r_wrist, transfer_r_wrist+2);
	clickButton(centerViewToPivotPoint);
	selNode(transfer_r_wrist);
	addMinus("location");
	decFieldCtrl("orientation", 2, 2);
//	list+=new ToggleField("in");

	collapse(creamGroup);

	list+=new Section("Transfer from pelvis to l_hip");
	collapse(r_shoulder);
	collapse(l_hip);
	list+=new SelectNode(l_hip);
	clickButton(centerViewToPivotPoint);
	list+=new MouseZoom(1);
	newNodeAsSiblingBelow(GROUPBUILD, creamGroup);
	selNode(blueGroup);
	decField("marker", 10);
	decField("marker", 10, 1);
	newNodeAsChild(TRANSFERBCYL, blueGroup);
	selNode(transfer_l_hip);
	decField("location", 96, 1);
	incField("location", 9);
	decFieldCtrl("orientation", 2, 2);
	list+=new MouseZoom(3);
	decField("radius", 25-10);
	decField("height", 50-33);
	incField("groupingHeight", 9);
	useNodeAsDest(l_hip, transfer_l_hip);
	list+=new ClickButton(openOwnership),
	list+=new MouseWheel(12);
	useNodeAsSource(pelvis, transfer_l_hip);
		
	list+=new Section("Transfer from pelvis to l_knee");
	list+=new MouseZoom(3);
	copyNodeAsChild(transfer_l_hip, blueGroup);
	useNodeAsReplacement(l_knee, transfer_l_knee+2);
	clickButton(centerViewToPivotPoint);
	selNode(transfer_l_knee);
	decField("location", 129-96, 1);
	//incField("height", 33-26);
	decField("groupingHeight", 9-5);
	decField("numOfGroups", 1);
//	list+=new ToggleField("in");

	list+=new Section("Transfer from pelvis to l_ankle");
	
	copyNodeAsChild(transfer_l_knee, blueGroup);
	useNodeAsReplacement(l_ankle, transfer_l_ankle+2);
	clickButton(centerViewToPivotPoint);
	selNode(transfer_l_ankle);
	decField("location", 163-129, 1);
	incField("location", 23-9, 0);
	incField("radius", 23-10);
	decField("numOfGroups", 1);
	decField("groupingHeight", 2);

//	list+=new ToggleField("in");



	list+=new Section(Transfer_Vertices_for_the_Right_Leg);
	//selNodeByName(name_front_view);
	list+=new MouseZoom(1),
	list+=new DragViewPos(0, .83, 0),

	copyNodeAsChild(transfer_l_hip, blueGroup);
	collapse(l_hip);
	collapse(r_hip);
	useNodeAsReplacement(r_hip, transfer_r_hip+2);
	selNode(transfer_r_hip);
	addMinus("location");

	copyNodeAsSiblingBelow(transfer_l_knee, transfer_r_hip);
	useNodeAsReplacement(r_knee, transfer_r_knee+2);
	selNode(transfer_r_knee);
	addMinus("location");

	copyNodeAsSiblingBelow(transfer_l_ankle, transfer_r_knee);
	useNodeAsReplacement(r_ankle, transfer_r_ankle+2);
	selNode(transfer_r_ankle);
	addMinus("location");
	collapse(blueGroup);
	
	list+=new Section(Transfer_pelvis_to_tummy0);
	collapse(r_hip);
	list+=new MouseWheel(10);
	collapse(neck0);
	newNodeAsSiblingBelow(GROUPBUILD, blueGroup);
	selNode(pinkGroup);
	decField("marker", 10, 1);
	decField("marker", 10, 2);
	newNodeAsChild(TRANSFERBCYL, pinkGroup);
	selNode(transfer_tummy0);
	decField("location", 85, 1);
	decField("radius", 25-20);
	decField("height", 50-5);
	useNodeAsSource(pelvis, transfer_tummy0);
	useNodeAsDest(tummy0, transfer_tummy0);
	list+=new ClickButton(openOwnership),
	selNode(transfer_tummy0);
//	list+=new ToggleField("in");

	list+=new Section(Transfer_pelvis_to_tummy1);
	copyNodeAsChild(transfer_tummy0, pinkGroup);
	useNodeAsReplacement(tummy1, transfer_tummy1+2);
	selNode(transfer_tummy1);
	incField("location", 10, 1);
//	list+=new ToggleField("in");

	list+=new Section(Transfer_pelvis_to_thorax);
	copyNodeAsChild(transfer_tummy1, pinkGroup);
	useNodeAsReplacement(thorax, transfer_thorax+2);
	selNode(transfer_thorax);
	incField("location", 75-64, 1);
	incField("height", 25-5);
//	list+=new ToggleField("in");

	list+=new Section(Transfer_pelvis_to_neck0);
	copyNodeAsChild(transfer_thorax, pinkGroup);
	useNodeAsReplacement(neck0, transfer_neck0+2);
	selNode(transfer_neck0);
	incField("location", 64-39, 1);
	decField("height", 25-2);
	decField("radius", 20-7);
//	list+=new ToggleField("in");

	list+=new Section(Transfer_pelvis_to_neck1);
	copyNodeAsChild(transfer_neck0, pinkGroup);
	useNodeAsReplacement(neck1, transfer_neck1+2);
	selNode(transfer_neck1);
	incField("location", 39-35, 1);
//	list+=new ToggleField("in");

	list+=new Section(Transfer_pelvis_to_head);
	copyNodeAsChild(transfer_neck1, pinkGroup);
	useNodeAsReplacement(head, transfer_head+2);
	list += new ClickButton(toggleXRayMode),
	selNode(transfer_head);
	incField("location", 35-32, 1);
	incField("height", 48-2);
	incField("radius", 26-7);
//	list+=new ToggleField("in");
	collapse(pinkGroup);
	clickButton(openOwnership);

	clickButton(saveSmls);
/////////////////////
	list+=new Section(Complete);
}
