/* Seamless3d

Copyright (C) 2001-2012 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/
extern const char* name_pelvis;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck0;
extern const char* name_neck1;
extern const char* name_hair;
extern const char* name_mouth;
extern const char* name_torsoSurface;
extern const char* name_headSurface;
extern const char* name_palmSurface;
extern const char* name_footSurface;

extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Pink_Group;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Head;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Complete;
extern const char* Add_a_Blue_Group;
extern const char* Copy_the_Left_Arm_to_the_Right;

extern const char* Move_the_Pivot_Points;
extern const char* menu_short_copy;
extern const char* menu_paste;
extern const char* menu_delete;
extern const char* menu_part;
extern const char* menu_coord;
extern const char* menu_copy_poly_map_to_source;

#define _WIN32_WINNT 0x0410


#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include"robot_aid.h"

void InputEvent::preNurbsPatchAvDemo(){
	g_robotDemo->fileName = "fuse-surface-av";
	g_robotDemo->function=nurbsPatchAvDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::nurbsPatchAvDemo(){
	const int seamless=1;
	const int pelvis=3;
	const int tummy0=	pelvis+1;
	const int tummy1=	tummy0+1;
	const int thorax=	tummy1+1;
	const int neck0=	thorax+1;
	const int neck1=	neck0+1;
	const int head=		neck1+1;
	const int hair=		head+1;
	const int mouth=	hair+1;
	const int l_eyeball=	mouth+1;
	const int r_eyeball=	l_eyeball+1;

	const int l_shoulder=	r_eyeball+1;
	const int l_elbow=		l_shoulder+1;
	const int l_wrist=		l_elbow+1;

	const int r_shoulder=	l_wrist+1;
	const int r_elbow=		r_shoulder+1;
	const int r_wrist=		r_elbow+1;

	const int l_hip=		r_wrist+1;
	const int l_knee=		l_hip+1;
	const int l_ankle=		l_knee+1;
	
	const int r_hip=		l_ankle+1;
	const int r_knee=		r_hip+1;
	const int r_ankle=		r_knee+1;

	const int thoraxMap = r_ankle+1;
	const int pelvisMap = thoraxMap+1;


	const int pinkGroup=r_ankle+1;
	const int torsoLathe=pinkGroup+1;
	const int armLathe=torsoLathe+2;
	const int legLathe=armLathe+2;
	const int copyArm=legLathe+2;

	const int torsoPatch=torsoLathe;
	const int torsoStem=torsoPatch+1;
	const int armPatch=torsoStem+2;
	const int armStem=armPatch+1;
	const int legPatch=armStem+2;
	const int legStem=legPatch+1;

	InputEvent* create_Skeleton_of_PartsArray[]={
		new Section("Create a new seamless file"),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "fuse-surface-av.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new ClickButton(openSceneTree),
		new Section("Add floor & height guide"),
		new ClickButton(floorBuild),
		new ToggleField("blaxxun_height"),

		new Section(Create_Skeleton_of_Parts),


	new SelectNode(pelvis),
	new ClickButton(toggleXRayMode),
	new ClickButton(setXRayEditMode),
	new MoveToPivotPoint(pelvis),
new Move3d(0,-.37),
new AddCtrlPnt(0,-.217), //tummy0
new AddCtrlPnt(0,-.155), //tummy1
new AddCtrlPnt(0,-.1), //thorax
new AddCtrlPnt(0,.129), //neck0
new AddCtrlPnt(0,.149), //neck1
new AddCtrlPnt(0,.166), //head
new MoveToPivotPoint(thorax),
new Move3d(0,-.1),
new AddCtrlPnt(.218,.007), //l_shoulder
new AddCtrlPnt(.401,.007), //l_elbow
new AddCtrlPnt(.584,.007), //l_wrist
new MoveToPivotPoint(pelvis),
new Move3d(0,-.37),
new AddCtrlPnt(.12,-.37), //l_hip
new AddCtrlPnt(.12,-.595), //l_knee
new AddCtrlPnt(.12,-.82), //l_ankle

		new NameNode(pelvis, name_pelvis),
		new NameNode(tummy0, name_tummy0),
		new NameNode(tummy1, name_tummy1),
		new NameNode(thorax, name_thorax),
		new NameNode(neck0, name_neck0),
		new NameNode(neck1, name_neck1),
		new NameNode(head, name_head),
		new NewNodeAsChild(PART, head),
		new NameNode(hair, name_hair),
		new NewNodeAsSiblingBelow(PART, hair),
		new NameNode(mouth, name_mouth),
		new NewNodeAsSiblingBelow(PART, mouth),
		new NameNode(l_eyeball, name_l_eyeball),
		new NewNodeAsSiblingBelow(PART, l_eyeball),
		new NameNode(r_eyeball, name_r_eyeball),

		new NameNode(l_shoulder, name_l_shoulder),
		new NameNode(l_elbow, name_l_elbow),
		new NameNode(l_wrist, name_l_wrist),

		new NameNode(l_hip, name_l_hip),
		new NameNode(l_knee, name_l_knee),
		new NameNode(l_ankle, name_l_ankle),
		new ClickButton(setXRayEditMode),

		new ClickButton(saveSmls),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);

///////////////////////////
	InputEvent* Lathe_for_torso_neck_and_headArray[]={
		new Section("Add lathe for torso, neck & head"),
		new NewNodeAsChild(GROUPBUILD, seamless),
		new SelectNode(pinkGroup),
		//new DecFieldY("marker", 5),
		//new DecFieldX("marker", 10),
		new SetFieldValue("marker","1 .9 .9"),
		new Collapse(l_shoulder),
		new Collapse(r_shoulder),
		new Collapse(l_hip),
		new Collapse(r_hip),

		new SelectNode(pelvis),
		new ClickButton(buildAvSegmentForSelPart),
		//new DecFieldY("translation", 122),
		new ClickControlPoint(0),
		new Move3d(Vec3f(0, -.02, 0)),
		new ClickControlPoint(4),
		new Move3d(Vec3f(0, .960915 - .02, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.108421, .960915 - .02, 0)),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.22497, - .02, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.241145, .2763 - .02, 0)),
		//new AddCtrlPnt(.174783, .598607),
		new AddCtrlPnt(.1803,.20015),
		//new IncFieldGroup("point"),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.182859, .45 - .02, 0)),
		new IncFieldX("bands", 16),
		new AddCtrlPnt(.158829,.224934),
		new AddCtrlPnt(.133657,.397708),
//		new IncFieldGroup("point"),
//		new IncFieldGroup("point"),
		new ClickControlPoint(4),
		new Move3d(Vec3f(.043112, .532188 - .02, 0)),
		new ClickControlPoint(5),
		new Move3d(Vec3f(.04041, .589351 - .02, 0)),
		new AddCtrlPnt(.074415,.385133),
		new AddCtrlPnt(.091264,.477179),
		//new IncFieldGroup("point"),
		//new IncFieldGroup("point"),
		new ClickControlPoint(6),
		new Move3d(Vec3f(.165385, .629022 - .02, 0)),
		new ClickControlPoint(7),
		new Move3d(Vec3f(.198995, .810491 - .02, 0)),
	};
	list+=EVENT_LIST(Lathe_for_torso_neck_and_headArray);

	InputEvent* Build_left_arm_Array[]={
		new Section("Add lathe for arm"),

		new SelectNode(l_shoulder),
		new ClickButton(buildAvSegmentForSelPart),
		new DecFieldX("staves", 4),
		new IncFieldCtrlY("translation", 3),
		new DecFieldCtrlX("translation", 38),
		new ToggleField("beginSP"),
		new ClickControlPoint(4),
		new Move3d(Vec3f(0, .510855, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.031634, .509308, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.036418, .471298, 0)),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.03374, .04456, 0)),
		new ClickControlPoint(0),
		new Move3d(Vec3f(.107385, -.002071, 0)),
		new ClickButton(centerViewToControlPoint),
		new MouseZoom(2),
		new IncFieldX("bands", 16),
		new AddCtrlPnt(.046631,.073645),
		//new IncFieldGroup("point"),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.03374, .04456, 0)),
		new AddCtrlPnt(.52,.144612),
		new AddCtrlPnt(.733369,.143273),
		//new IncFieldGroup("point"),
		//new IncFieldGroup("point"),
		new ClickButton(centerViewToControlPoint),
		new ClickControlPoint(4),
		new Move3d(Vec3f(.02481, .409873, 0)),
		new AddCtrlPnt(.151943,.01027),
		//new IncFieldGroup("point"),
		new ClickControlPoint(5),
		new Move3d(Vec3f(.034889, .428337, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.031184, .164928, 0)),
		//new IncFieldGroup("point"),
		new AddCtrlPnt(-.154426,.015503),
	};
	list+=EVENT_LIST(Build_left_arm_Array);

	InputEvent* Build_left_leg_Array[]={
		new Section("Add lathe for leg"),
		new DragViewPos(0, .9, 0),
		new MouseZoom(1),
		new SelectNode(l_hip),
		new ClickButton(buildAvSegmentForSelPart),
		new DecFieldX("staves", 2),
		//new IncFieldCtrlZ("rotation", 2),
		new DecFieldY("translation", 2),
		new ToggleField("beginSP"),
		//new IncFieldX("translation", 12),
		new ClickButton(centerViewToControlPoint),
		new MouseZoom(2),
		new ClickControlPoint(4),
		new Move3d(Vec3f(0, .529, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.087721, .529, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.031731, .417603, 0)),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.043647, .005, 0)),
		new ClickControlPoint(0),
		new Move3d(Vec3f(.082042, 0, 0)),
		new AddCtrlPnt(-.125689,-.005),
		
		//new IncFieldGroup("point"),
		new IncFieldX("bands", 16),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.043647, .005, 0)),
		new AddCtrlPnt(-.075378,-.422602),
		//new IncFieldGroup("point"),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.035704, .08, 0)),
		new AddCtrlPnt(-.075378,-.422602),
		//new IncFieldGroup("point"),
		//new ClickControlPoint(5),
		//new Move3d(Vec3f(.031731, .417603, 0)),
		//new IncFieldGroup("point"),
		//new IncFieldGroup("point"),
		new AddCtrlPnt(-.136518,-.980557),
		new AddCtrlPnt(-.097301,-.902531),
		new ClickControlPoint(7),
		new Move3d(Vec3f(.093247, .47139, 0)),
		new ClickControlPoint(6),
		new Move3d(Vec3f(.04965, .440119, 0)),
	};
	list+=EVENT_LIST(Build_left_leg_Array);

	InputEvent* Copy_left_to_rightArray[]={
		new Section("Copy left to right"),
		new MouseZoom(1),
		new NewNodeAsChild(COPYPART, pinkGroup),
		new UseNodeAsSource(armLathe+1, copyArm),
		new UseNodeAsDest(r_shoulder, copyArm),
		new SelectNode(copyArm),
		new ToggleField("mirrorX"),

		new UseNodeAsSource(legLathe+1, copyArm),
		new UseNodeAsDest(r_hip, copyArm),
	};
	list+=EVENT_LIST(Copy_left_to_rightArray);

	InputEvent* ConvertToPatchesArray[]={
		new Section("Convert lathes to patches"),
		new MoveToNode(torsoLathe),
		new RightClick,
		new Move_MenuItem("convert to patch"),
		new Click,

		new MoveToNode(armStem-1),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,

		new MoveToNode(armStem-1),
		new RightClick,
		new Move_MenuItem("convert to patch"),
		new Click,

		new MoveToNode(armStem+2),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,

		new MoveToNode(armStem+2),
		new RightClick,
		new Move_MenuItem("convert to patch"),
		new Click,

		new MoveToNode(armStem+5),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
	};
	list+=EVENT_LIST(ConvertToPatchesArray);

///////////////////////////
	InputEvent* Tug_torso_neck_and_head_pointsArray[]={
		new Section("Tug torso, neck & head points"),
		new SelectNode(torsoPatch),
		new ToggleField("mirror"),
		//new ClickButton(setLeftViewOrientation),
		new DragViewPos(0,1.068884,0),
		new MouseZoom(1.4641),
		new ClickButton(setRightViewOrientation),
		new TugVertex(10,-.230563,-.221248),
		new TugVertex(12,.230565,-.221249),
		new TugVertex(19,-.247141,.183282),
		new TugVertex(21,.247144,.183282),
		new TugVertex(28,-.187406,.437597),
		new TugVertex(30,.187409,.437597),
		new TugVertex(37,-.073203,.557927),
		//new TugVertex(39,.058565,.557927),
		//new TugVertex(46,-.058562,.641621),
		//new TugVertex(48,.041417,.641621),
		new TugVertex(55,-.169496,.699702),
		new TugVertex(57,.307461,.699702),
		new TugVertex(64,-.203944,.96539),
		new TugVertex(66,.366026,.965391),
		new TugVertex(73,-.111117,1.185627),
		new TugVertex(75,.224616,1.185627),
		new DragViewRot(.278432,.921622,.270348,1.665886),
		new TugVertex(82,.014046,.990101),
		new ClickButton(setBirdsEyeViewOrientation),
		new ClickButton(toggleWireFrame),
		new TugVertex(81,0,-.058565),
	};
	list+=EVENT_LIST(Tug_torso_neck_and_head_pointsArray);

	InputEvent* Tug_arm_pointsArray[]={
		new Section("Tug arm points"),
		//new ClickButton(toggleXRayMode),
		new ClickButton(setFrontViewOrientation),
		//new SelectNode(torsoPatch),
		new Hide(torsoPatch),
		//new ToggleField("cage"),
		new Hide(legPatch),
		//new SelectNode(legPatch),
		//new ToggleField("cage"),
		new SelectNode(armPatch),
new VirtKeyDown(VK_LCONTROL),
new Wait(.25),
new TypeString("t"),
new VirtKeyUp(VK_LCONTROL),
		new ToggleField("sameScreenPosition"),
		new TugVertex(32-9,.328778,.314993),
		new ClickButton(centerViewToControlPoint),
		new MouseZoom(6.074727),
new TugVertex(1,-.544056,.648416),
new TugVertex(10,-.252462,.458126),
new TugVertex(19,.01482,.374923),
new TugVertex(23,-.076296,.000005),
new TugVertex(14,-.057946,-.20812),
new TugVertex(5,-.033779,-.353917),

		new MouseZoom(2.554985),
		new DragViewPos(-.445711,.885684,.031183),
		new SelectNode(41),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new SelectNode(armPatch),

new TugVertex(32,-.257499,.080953),
new TugVertex(28,-.257499,.236806),
new TugVertex(41,.055416,.10139),
new TugVertex(37,.055416,.222855),

//		new TugVertex(50-9,.055415,.107291),
//		new TugVertex(48-9,.055415,.222855),

		new TugVertex(59-9,.36833,.129834),
		new TugVertex(57-9,.36833,.191614),

		new TugVertex(68-9,.407809,.10934),
		new TugVertex(66-9,.407809,.213345),

		new TugVertex(77-9,.520139,.103407),
		new TugVertex(75-9,.515008,.225082),

		new TugVertex(86-9,.627515,.125484),
		new TugVertex(84-9,.62495,.210161),

		new ClickButton(setBirdsEyeViewOrientation),

		new TugVertex(55-9,.368331,-.036284),
		new TugVertex(57-9,.373331,-.11806),
		new TugVertex(48-9,.055416,-.141204),
		new TugVertex(46-9,.055416,-.02314),

		new Hide(pelvis),
		new SelectNode(armPatch),

new DragViewPos(-.223597,.885684,.011614),

new TugVertex(3,-.226366,-.234074),
new TugVertex(1,-.226366,.174727),
new TugVertex(12,-.103724,-.147203),
new TugVertex(10,-.103724,.087856),
//new TugVertex(21,.008693,-.115879),
//new TugVertex(19,.008693,.056533),
//new TugVertex(30,.309998,-.109346),
//new TugVertex(28,.309998,.05),
new TugVertex(16,-.021912,.087856),
new TugVertex(7,-.011748,.174727),
new TugVertex(14,-.021912,-.147203),
new TugVertex(5,-.011748,-.234074),

new Hide(pelvis),

		new ClickButton(setFrontViewOrientation),
		new DragViewPos(0,1.068884,0),
		new MouseZoom(1.4641),

	};
	list+=EVENT_LIST(Tug_arm_pointsArray);


	InputEvent* Tug_leg_pointsArray[]={
		new Section("Tug leg points"),
		//new ClickButton(setFrontViewOrientation),
		//new SelectNode(legPatch),
		new Hide(legPatch),
		//new ToggleField("cage"),
		//new ToggleField("sameViewPositionTug"),
		//new DragViewPos(-.086283, 1.4688, -3.033718),
		new DragViewPos(-.086283,1.4688,-.033718),

		new MouseZoom(3.400686),
new TugVertex(3,.38707,1.051397),
new TugVertex(5,-.187141,.85223),
new TugVertex(14,-.11163,.847622),
new TugVertex(10,.331094,.968971),
new TugVertex(19,.271878,.877377),
new TugVertex(23,-.033575,.815506),
//new TugVertex(32,-.008697,.574036),
new TugVertex(28,.274066,.574036),
new ClickButton(setLeftViewOrientation),

////
new DragViewPos(-.086283,1.534228,-.133698),
new TugVertex(75,-.179242,-.730369),
new TugVertex(66,-.132462,-.563794),
new TugVertex(73,.652674,-.730369),
new TugVertex(64,.632793,-.520175),
new TugVertex(55,.569575,-.465478),
new ClickButton(setWormsEyeViewOrientation),

new TugVertex(82,.119661,-.254664),
new DragViewRot(-.627902,-.532655,-.567467,1.751982),
new DragViewRot(.464109,-.211332,-.860199,2.015512),
new DragViewRot(.985245,.141894,-.095704,2.706425),

/*
new TugVertex(41,-.001141,-.00408),
new TugVertex(39,.247918,-.00408),
new TugVertex(50,.006414,-.571846),
new TugVertex(46,.220471,-.555153),
new TugVertex(59,-.061777,-.624214),
new TugVertex(57,.311285,-.629447),
new TugVertex(68,-.214563,-.761871),
new TugVertex(66,.501675,-.771297),
new ClickButton(setLeftViewOrientation),
/*

new DragViewPos(-.086283,1.473211,-.124876),
new TugVertex(75,-.209239,-.937871),
new TugVertex(79,.647282,-.937871),
new TugVertex(66,-.162459,-.756296),
new TugVertex(70,.623654,-.737045),
new TugVertex(57,.201638,-.614446),
new TugVertex(55,.554578,-.66798),
new TugVertex(61,.558509,-.659213),
new ToggleField("sameViewPositionTug"),
////////
new ClickButton(setFrontViewOrientation),
new Hide(r_hip),
new SelectNode(35),
new ClickButton(setRightViewOrientation),

new DragViewPos(-.086283,1.469535,.011127),
new TugVertex(68,.624945,-.76937),
new TugVertex(59,.261684,-.631713),
new TugVertex(61,-.091006,-.656713),
new TugVertex(64,-.13615,-.744544),
new DragViewPos(-.186262,1.486444,.011127),


new ClickButton(setBackViewOrientation),
new DragViewPos(-.202436, 1.498942, 0),
new TugVertex(73,.023926,-.850368),
new TugVertex(79,.543219,-.850368),
new TugVertex(64,-.067028,-.640174),
new TugVertex(70,.585319,-.649542),
new TugVertex(55,.104395,-.585477),
new TugVertex(61,.441589,-.574517),
		new MouseZoom(1.388117),
		new DragViewPos(0,1.045706,0),

new Hide(r_hip),
*/
	};
	list+=EVENT_LIST(Tug_leg_pointsArray);


	InputEvent* Optimize_vertex_rings_for_torsoArray[]={
		new Section("Optimize vertex rings for torso"),

		new ClickButton(setFrontViewOrientation),

		new MouseZoom(1.694613),
		new DragViewPos(-.015077,1.019482,0),
		new ClickButton(toggleWireFrame),

		new SelectNode(torsoStem),
		new SetIndex("height", 1),
		new IncFieldGroup("height"),
		new DecFieldX("height",39),

		new DecFieldX("bands",10),
		new SetIndex("height", 2),
		new IncFieldGroup("height"),
		new DecFieldX("height",13),
		new IncFieldX("bands", 2),
		new SetIndex("height", 3),
		new IncFieldGroup("height"),
		new DecFieldX("height",15),
		new SetIndex("height", 4),
		new IncFieldX("bands", 6),

	};
	list+=EVENT_LIST(Optimize_vertex_rings_for_torsoArray);

	InputEvent* Optimize_vertex_rings_for_armArray[]={
		new Section("Optimize vertex rings for arm"),
		new DragViewPos(-.392745,.987027,0),
		new MouseZoom(2.732099),
		new SelectNode(armStem),
		new IncIndex("height"),
		new IncFieldGroup("height"),
		new DecFieldX("height",50-15),
		new IncFieldCtrlX("height",3),
		new DecFieldX("bands",13),

		new IncIndex("height"),
		new IncFieldGroup("height"),
		new DecFieldX("height",40),
		new IncFieldCtrlX("height",2),
		new DecFieldX("bands",4),

		new IncIndex("height"),
		new IncFieldGroup("height"),
		new IncFieldX("bands", 1),
		new DecFieldX("height",21),
		new DecFieldCtrlX("height",3),

		new IncIndex("height"),
		new IncFieldGroup("height"),
		new DecFieldX("height",30),
		new DecFieldCtrlX("height",6),
		new IncFieldX("bands"),
		new IncIndex("height"),
		new IncFieldX("bands",17),
	};
	list+=EVENT_LIST(Optimize_vertex_rings_for_armArray);

	InputEvent* Optimize_vertex_rings_for_legArray[]={
		new Section("Optimize vertex rings for leg"),
		new DragViewPos(-.09993,1.443637,0),
		new SelectNode(legStem),
		new IncIndex("height"),
		new IncFieldGroup("height"),
		new DecFieldX("bands",13),
		new DecFieldX("height",33),

		new IncIndex("height"),
		new IncFieldGroup("height"),
		new DecFieldX("bands", 2),
		new DecFieldX("height",18),
		new DecFieldCtrlX("height",5),

		new IncIndex("height"),
		new IncFieldGroup("height"),
		new DecFieldX("bands"),
		new DecFieldX("height",27),
		new IncFieldCtrlX("height",3),

		new IncIndex("height"),
		new IncFieldGroup("height"),
		new IncFieldX("bands", 3),
		new DecFieldX("height", 13),
		new IncIndex("height"),
		new IncFieldX("bands",9),

	};
	list+=EVENT_LIST(Optimize_vertex_rings_for_legArray);
/*
	InputEvent* move_the_Pivot_PointsArray[]={
		new Section("Move pivot points"),
		new MouseZoom(1),
		new DragViewPos(-.015077,1.019482,0),
		new Collapse(r_hip),
		new Collapse(l_hip),
		new Collapse(r_shoulder),
		new Collapse(l_shoulder),
		new SelectNode(pelvis),
		new DecButtonY(decPivotX, 120),
		new MouseZoom(2),
		new SelectNode(tummy0),
		new IncButtonY(decPivotX, 15),
		new IncButtonCtrlY(decPivotX, 3),
		new SelectNode(tummy1),
		new IncButtonY(decPivotX, 6),
		new IncButtonCtrlY(decPivotX, 2),
		new SelectNode(thorax),
		new IncButtonY(decPivotX, 5),
		new IncButtonCtrlY(decPivotX, 5),
		new SelectNode(neck0),
		new IncButtonY(decPivotX, 23),
		new DecButtonCtrlY(decPivotX, 1),
		new SelectNode(neck1),
		new IncButtonY(decPivotX, 2),
		new SelectNode(head),
		new IncButtonY(decPivotX, 2),
		new DecButtonCtrlY(decPivotX, 3),
////////
		new SelectNode(l_shoulder),
		new IncButtonY(decPivotX, 11),
		new IncButtonX(decPivotX, 22),
		new ClickButton(centerViewToPivotPoint),
		new MouseZoom(3),
		new DecButtonCtrlX(decPivotX, 2),
		new DecButtonCtrlY(decPivotX, 3),
		new SelectNode(l_elbow),
		new IncButtonX(decPivotX, 18),
		new ClickButton(centerViewToPivotPoint),
		new IncButtonCtrlX(decPivotX, 3),
		new SelectNode(l_wrist),
		new IncButtonX(decPivotX, 18),
		new ClickButton(centerViewToPivotPoint),
		new IncButtonCtrlX(decPivotX, 3),
		//new IncButtonCtrlX(decPivotX, 7),

		new SelectNode(r_shoulder),
		new ClickButton(centerViewToPivotPoint),
		new IncButtonY(decPivotX, 11),
		new DecButtonX(decPivotX, 22),
		new ClickButton(centerViewToPivotPoint),
		new IncButtonCtrlX(decPivotX, 2),
		new DecButtonCtrlY(decPivotX, 3),
		new SelectNode(r_elbow),
		new DecButtonX(decPivotX, 18),
		new ClickButton(centerViewToPivotPoint),
		new DecButtonCtrlX(decPivotX, 3),
		new SelectNode(r_wrist),
		new DecButtonX(decPivotX, 18),
		new ClickButton(centerViewToPivotPoint),
		new DecButtonCtrlX(decPivotX, 3),

//		new Collapse(l_hip),
		new SelectNode(l_hip),
		new ClickButton(centerViewToPivotPoint),
		new IncButtonX(decPivotX, 12),
		//new IncButtonCtrlX(decPivotX, 7),
		new SelectNode(l_knee),
		new DecButtonY(decPivotX, 22),
		new ClickButton(centerViewToPivotPoint),
		new DecButtonCtrlY(decPivotX, 5),
		new SelectNode(l_ankle),
		new DecButtonY(decPivotX, 22),
		new DecButtonCtrlY(decPivotX, 5),

//		new Collapse(r_hip),
		new SelectNode(r_hip),
		new ClickButton(centerViewToPivotPoint),
		new DecButtonX(decPivotX, 12),
		//new DecButtonCtrlX(decPivotX, 7),
		new SelectNode(r_knee),
		new DecButtonY(decPivotX, 22),
		new ClickButton(centerViewToPivotPoint),
		new DecButtonCtrlY(decPivotX, 5),
		new SelectNode(r_ankle),
		new DecButtonY(decPivotX, 22),
		new DecButtonCtrlY(decPivotX, 5),
	};
	list+=EVENT_LIST(move_the_Pivot_PointsArray);
*/
	InputEvent* Transfer_ownership_for_torsoArray[]={
		new Section("Transfer ownership for torso"),
		new DragViewPos(0,.819167,0, -.4, 1.2),
		new Collapse(r_hip),
		new Collapse(l_hip),
		new Collapse(r_shoulder),
		new Collapse(l_shoulder),
		new Collapse(26),
		new NewNodeAsSiblingBelow(GROUPBUILD, 26),
		new SelectNode(41),
		new SetFieldValue("marker",".8 1 .8"),
		new NewNodeAsChild(TRANSFEROWNERSHIP, 41),
		new UseNodeAsSource(pelvis, 42),
		new UseNodeAsDest(43, 42),
		new UseNodeAsDest(tummy0, 42),
		new UseNodeAsDest(tummy1, 42),
		new UseNodeAsDest(thorax, 42),
		new UseNodeAsDest(neck0, 42),
		new UseNodeAsDest(neck1, 42),
		new UseNodeAsDest(head, 42),
		new ClickButton(openOwnership),
		new SelectNode(42),
		new ToggleField("beginSP"),
		new IncFieldGroup("numOf"),
		new IncFieldX("qty",15),
		new IncFieldX("numOf",7),
		new IncFieldGroup("numOf"),
		new DecFieldX("numOf",6),
		new IncFieldGroup("numOf"),
		new IncFieldGroup("numOf"),
		new IncFieldX("numOf",7),
		new IncFieldGroup("numOf"),
		new DecFieldX("numOf",7),
		new IncFieldGroup("numOf"),
/*
//		new Section("crap"),
		new CopyNodeAsChild(43, 42),
		new UseNodeAsReplacement(46+2, 46+1),
		new UseNodeAsReplacement(tummy1, 46+2),
		new SelectNode(46),
		new ToggleField("beginSP"),
		new DecFieldX("fromVertex",6),

		new CopyNodeAsChild(46, 42),
		new UseNodeAsReplacement(49+2, 49+1),
		new UseNodeAsReplacement(thorax, 49+2),

		new CopyNodeAsChild(49, 42),
		new UseNodeAsReplacement(52+2, 52+1),
		new UseNodeAsReplacement(neck0, 52+2),
		new SelectNode(52),
		new IncFieldX("fromVertex",7),

		new CopyNodeAsChild(52, 42),
		new UseNodeAsReplacement(55+2, 55+1),
		new UseNodeAsReplacement(neck1, 55+2),
		new SelectNode(55),
		new DecFieldX("fromVertex",7),

		new CopyNodeAsChild(55, 42),
		new UseNodeAsReplacement(58+2, 58+1),
		new UseNodeAsReplacement(head, 58+2),
		*/
	};
	list+=EVENT_LIST(Transfer_ownership_for_torsoArray);

	InputEvent* Transfer_ownership_for_armsArray[]={
		new Section("Transfer ownership for arms"),
		new Collapse(42),
		new Collapse(neck0),
		new NewNodeAsChild(TRANSFEROWNERSHIP, 41),
		new UseNodeAsSource(l_shoulder, 51),
		new UseNodeAsDest(thorax, 51),
		new UseNodeAsDest(l_shoulder, 51),
		new UseNodeAsDest(l_elbow, 51),
		new UseNodeAsDest(l_wrist, 51),
		new SelectNode(51),
		new IncFieldGroup("numOf"),
		new IncFieldX("qty",11),
		new IncFieldX("numOf",4),
		new IncFieldGroup("numOf"),
		new IncFieldX("numOf",5),
		new DragViewPos(-.4575,.831667,0),
		new IncFieldGroup("numOf"),
		new DecFieldX("numOf",1),

		new DragViewPos(.400833,.789167,0, -1, -.2),
		new CopyNodeAsChild(51, 41),
		new UseNodeAsReplacement(r_shoulder, 57+1),
		new UseNodeAsReplacement(57+1, 57+3),
		new UseNodeAsReplacement(r_elbow, 57+4),
		new UseNodeAsReplacement(r_wrist, 57+5),
	};
	list+=EVENT_LIST(Transfer_ownership_for_armsArray);

	InputEvent* Transfer_ownership_for_legsArray[]={
		new Section("Transfer ownership for legs"),
		new DragViewPos(.0225,1.555001,0, 0, -1),
		new Collapse(57),
		new Collapse(51),
		new Collapse(tummy0),


		new NewNodeAsChild(TRANSFEROWNERSHIP, 41),
		new UseNodeAsSource(l_shoulder, 63),
		new UseNodeAsDest(pelvis, 63),
		new UseNodeAsDest(l_hip, 63),
		new UseNodeAsDest(l_knee, 63),
		new UseNodeAsDest(l_ankle, 63),
		new SelectNode(63),
		new IncFieldGroup("numOf"),
		new IncFieldX("qty",13),
		new IncFieldX("numOf",1),
		new IncFieldGroup("numOf"),
		new IncFieldX("numOf",8),
		new IncFieldGroup("numOf"),
		new DecFieldX("numOf",1),

		new CopyNodeAsChild(63, 41),
		new UseNodeAsReplacement(r_hip, 69+1),
		new UseNodeAsReplacement(69+1, 69+3),
		new UseNodeAsReplacement(r_knee, 69+4),
		new UseNodeAsReplacement(r_ankle, 69+5),
	};
	list+=EVENT_LIST(Transfer_ownership_for_legsArray);

	InputEvent* Set_vertex_weightsArray[]={
		new Section("Set vertex weights"),
		new Collapse(tummy0),
		new SelectNode(l_shoulder),
		new ClickButton(centerViewToPivotPoint),
		new MouseZoom(12),

		//new IncFieldZ("rotation",55),
		new ToggleField("insert", 1),
		new IncFieldX("coords", 12),

		new ToggleField("insert"),
		new IncFieldX("coords", 12),

		new ToggleField("insert"),
		new IncFieldX("coords", 12),

		new SelectNode(l_elbow),
		new ClickButton(centerViewToPivotPoint),
		//new DecFieldZ("rotation",48),
		new ToggleField("insert", 1),
		new IncFieldX("coords", 12),

		new ToggleField("insert"),
		new IncFieldX("coords", 12),

		new SelectNode(l_wrist),
		new ClickButton(centerViewToPivotPoint),

		new ToggleField("insert", 1),
		new IncFieldX("coords", 12),


		new SelectNode(r_shoulder),
		new ClickButton(centerViewToPivotPoint),

		new ToggleField("insert", 1),
		new IncFieldX("coords", 12),

		new ToggleField("insert"),
		new IncFieldX("coords", 12),

		new ToggleField("insert"),
		new IncFieldX("coords", 12),

		new SelectNode(r_elbow),
		new ClickButton(centerViewToPivotPoint),

		new ToggleField("insert", 1),
		new IncFieldX("coords", 12),

		new ToggleField("insert"),
		new IncFieldX("coords", 12),

		new SelectNode(r_wrist),
		new ClickButton(centerViewToPivotPoint),

		new ToggleField("insert", 1),
		new IncFieldX("coords", 12),
	};
	list+=EVENT_LIST(Set_vertex_weightsArray);


	InputEvent* Set_vertex_weights_for_legsArray[]={
		new SelectNode(l_hip),
		new ClickButton(centerViewToPivotPoint),

		new ToggleField("insert", 1),
		new IncFieldX("coords", 14),

		new ToggleField("insert"),
		new IncFieldX("coords", 14),

		new SelectNode(l_knee),
		new ClickButton(centerViewToPivotPoint),
//		new DecFieldZ("rotation",31),
		new ToggleField("insert", 1),
		new IncFieldX("coords", 14),

		new ToggleField("insert"),
		new IncFieldX("coords", 14),

		new SelectNode(l_ankle),
		new ClickButton(centerViewToPivotPoint),

//		new DecFieldZ("rotation",24),
		new ToggleField("insert", 1),
		new IncFieldX("coords", 14),

		new SelectNode(r_hip),
		new ClickButton(centerViewToPivotPoint),

//		new IncFieldZ("rotation",26),
		new ToggleField("insert", 1),
		new IncFieldX("coords", 14),

		new ToggleField("insert"),
		new IncFieldX("coords", 14),

		new SelectNode(r_knee),
		new ClickButton(centerViewToPivotPoint),
		new ToggleField("insert", 1),
		new IncFieldX("coords", 14),

		new ToggleField("insert"),
		new IncFieldX("coords", 14),

		new SelectNode(r_ankle),
		new ClickButton(centerViewToPivotPoint),

//		new DecFieldZ("rotation",24),
		new ToggleField("insert", 1),
		new IncFieldX("coords", 14),
		//new ClickButton(openOwnership),

	};
	list+=EVENT_LIST(Set_vertex_weights_for_legsArray);

	InputEvent* Add_colorArray[]={
		new Section("Color torso, arms & legs"),
		new Collapse(41),
		new NewNodeAsSiblingBelow(GROUPBUILD, 41),
		new SelectNode(75),
		new SetFieldValue("marker","1 1 .8"),
		new SelectNode(pelvis),

		new MouseZoom(1.262298),
		new DragViewPos(.048788,1.182861,0),
		new ClickButton(toggleXRayMode),
		new ClickButton(colorSweepForSelParts),
		new IncFieldGroup("color"),
		new DecFieldY("location", 167),
		new SetFieldValue("color","0 1 0"),
		new DecIndex("color"),
		new SetFieldValue("color","0 1 1"),
		new DecFieldX("location", 78),
		new IncFieldZ("orientation", 29),
		new IncIndex("color"),
		new IncFieldX("distance", 54),

		new UseNodeAsDest(tummy0, 76),
		new UseNodeAsDest(tummy1, 76),
		new UseNodeAsDest(thorax, 76),
		//new Collapse(tummy0),
		new UseNodeAsDest(l_shoulder, 76),
		new UseNodeAsDest(l_elbow, 76),
		new UseNodeAsDest(r_shoulder, 76),
		new UseNodeAsDest(r_elbow, 76),
		new UseNodeAsDest(l_hip, 76),
		new UseNodeAsDest(l_knee, 76),
		new UseNodeAsDest(r_hip, 76),
		new UseNodeAsDest(r_knee, 76),
		new Collapse(76),

		new Section("Color neck, head & hands"),

		new Collapse(neck0),
		new SelectNode(neck0),
		new ClickButton(colorSweepForSelParts),
		new IncFieldGroup("color"),

		//new IncFieldCtrlZ("orientation"),
		new DecFieldY("location",86),
		//new IncFieldX("location",58),
		new SetFieldValue("color",".9 .67 .55"),
		new DecIndex("color"),
		new SetFieldValue("color",".9 .67 .55"),
		new UseNodeAsDest(neck1, 89),
		new UseNodeAsDest(head, 89),
		new UseNodeAsDest(l_wrist, 89),
		new UseNodeAsDest(r_wrist, 89),

		new Section("Color feet"),
		new Collapse(89),

		new SelectNode(l_ankle),
		new ClickButton(colorSweepForSelParts),

		new IncFieldGroup("color"),

		new DecFieldY("location",178),
		new DecFieldX("distance", 100-6),
		new SetFieldValue("color","1 1 0"),
		new DecIndex("color"),
		new SetFieldValue("color","1 1 0"),
		new IncFieldGroup("color"),
		new SetFieldValue("color", "1"),
		new SetFieldValue("distance","0"),
		new IncFieldGroup("color"),
		new SetFieldValue("distance","1"),
		new UseNodeAsDest(r_ankle, 95),
	};
	list+=EVENT_LIST(Add_colorArray);


	InputEvent* Add_the_eyesArray[]={
		new Section("Add eyes"),
		new ClickButton(toggleXRayMode),
		new MouseZoom(1.4641),
		new DragViewPos(0,1.068884,0),
		new ClickButton(invertBackgroundColor),
		new Collapse(75),
		new Collapse(26),
		new Collapse(r_hip),
		new Collapse(l_hip),
		new Collapse(r_shoulder),
		new Collapse(l_shoulder),
		new SelectNode(l_eyeball),
		new ClickButton(buildSphereForSelPart),
		new ClickButton(setLeftViewOrientation),
		new ToggleField("yCentred"),
		new DecFieldCtrlX("rotation"),

		new IncFieldY("translation",26),
		new DecFieldX("radius",25-7),
		new IncFieldZ("translation",11),
		new ClickButton(setFrontViewOrientation),

		new IncFieldX("translation",6),
		new DecFieldY("rotation", 3),

		new SelectNode(l_eyeball),
		new ClickButton(colorSweepForSelParts),
		new IncFieldGroup("color"),
		new DecFieldY("location",41),
		new DecFieldCtrlY("location",3),
		new IncFieldX("location",5),
		new ClickButton(setLeftViewOrientation),
		new DecFieldCtrlX("orientation"),
		new IncFieldZ("location",9),
		new IncFieldCtrlZ("location",7),
		new DecFieldX("distance",100-10),
		new DecFieldCtrlX("distance",3),
		new IncFieldGroup("color"),
		new SetFieldValue("color","0"),
		new DecFieldX("distance",3),
		new DecFieldCtrlX("distance",3),
		new ClickButton(setFrontViewOrientation),
		new DecFieldY("orientation", 6),

		new ClickButton(toggleWireFrame),
		new MoveNodeAsChild(36, pinkGroup),
		new UseNodeAsSource(l_eyeball, 40),
		new UseNodeAsDest(r_eyeball, 40),
new ClickButton(toggleWireFrame),
new SelectNode(l_eyeball),
new IncFieldY("pivotPoint",26),
new IncFieldX("pivotPoint", 6),
new ClickButton(setLeftViewOrientation),
new IncFieldZ("pivotPoint",18),
new DecFieldCtrlY("pivotPoint", 3),
new DragViewRot(-.706648,-.352795,.613339,.76747),
new SelectNode(r_eyeball),
new SetFieldValue("pivotPoint","-.06 .257 .18"),
new ClickButton(toggleXRayMode),
	};
	list+=EVENT_LIST(Add_the_eyesArray);

	InputEvent* Fuse_the_arm_to_the_torsoArray[]={
		new Section("Fuse arm to torso"),
		new ClickButton(invertBackgroundColor),
		new ClickButton(setFrontViewOrientation),
		new DragViewPos(0,.768358,.0),
		//new NameNode(torsoPatch, "torsoPatch"),
		new NewNodeAsChild(FUSESURFACE, torsoStem),
		new MoveNodeAsDest(armPatch+1, torsoStem+2),
		new SelectNode(torsoStem+2),
//		new IncFieldCtrlZ("orientation"),
		new DragViewRot(-.131176,-.991152,-.020283,1.947625),
		new IncFieldX("qty", 12),
		new ToggleField("spread"),
		new DragViewRot(-.057956,-.989914,-.129275,.97998),
		new ClickButton(doBuild, 10),

		//new MoveToField("coordChange"),
		//new Click,
		//new TypeVirtKey(VK_RIGHT),
		//new TypeString("0"),
		//new ClickButton(doBuild, 20),
/*
		new Section("Influence the arm's 2nd & 3rd rings"),
		new SetFieldValue("vSpan",".153"),
		new IncFieldX("numOf"),
		new IncFieldX("numOf"),
		new IncFieldX("numOf"),
		new ToggleField("spread"),
		new ClickButton(doBuild, 10),
*/
		new Section("Fuse leg to torso"),
		new NewNodeAsChild(FUSESURFACE, torsoStem),
		new MoveNodeAsDest(legPatch+2, torsoStem+6),
		new SelectNode(torsoStem+6),

		new DragViewRot(-.013943,-.999379,-.03237,2.618577),
		new DragViewPos(-.044966,1.15915,-.001864),
		new IncFieldX("qty", 14),
		new ToggleField("spread"),


		new DragViewRot(-.154132,-.734955,.660367,2.92011),
		new DragViewRot(-.1387,-.828036,.543248,2.882223),
		new DragViewRot(-.983707,.131912,-.122144,.708635),
		new MouseZoom(4.784251),
		new ClickButton(doBuild, 10),
/*
		new Section("Influence the leg's 2nd & 3rd rings"),
		new SetFieldValue("vSpan",".17"),
		new IncFieldX("numOf"),
		new IncFieldX("numOf"),
		new IncFieldX("numOf"),
		new ToggleField("spread"),
		new ClickButton(doBuild, 10),
*/
	};
	list+=EVENT_LIST(Fuse_the_arm_to_the_torsoArray);

	InputEvent* Build_flat_triangles_in_4_stagesArray[]={
/*
		new Section("Check autoIn"),
		new SelectNode(seamless),
		new ToggleField("autoIn"),
*/
		new Section("Isolate triangles for pelvis & thorax"),
		//new Collapse(27),
		//new NewNodeAsSiblingAbove(EXITBUILD, 38),
		//new Collapse(27),

		new Hide(torsoStem+1),
		new CopyNodeAsChild(torsoStem, torsoPatch),
		new MoveToNode(torsoPatch+13),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new MoveToNode(34),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new UseNodeAsReplacement(thorax, torsoPatch+2),
		new Hide(torsoPatch+2),
		new CopyNodeAsSiblingAbove(34, torsoPatch+1),
		new UseNodeAsReplacement(tummy0, torsoPatch+2),
		new Hide(torsoPatch+2),
		new MoveToNode(torsoPatch+3),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,

		new CopyNodeAsSiblingAbove(torsoPatch+1, torsoPatch+1+2),
		new UseNodeAsReplacement(neck0, torsoPatch+2),

		new Section("Set bands for neck & head"),
		new ClickButton(setFrontViewOrientation),
		new MouseZoom(2.941231),
		new DragViewPos(.004703,.932298,-.132668),

		new SelectNode(28),
		new SetIndex("height", 0),
		new DecFieldGroup("height"),
		new DecFieldGroup("height"),
		new ToggleField("beginSP"),
		new Hide(28+1),

		new Section("Set bands for tummy"),

		new Hide(30+1),
		new SelectNode(30),
		new DecFieldGroup("height"),
		new ToggleField("beginSP"),
		new ToggleField("endSP"),
		new SetIndex("height", 4),
		new DecFieldGroup("height"),
		new DecFieldGroup("height"),
		new DecFieldX("height",25),
		new IncFieldCtrlX("height",2),
		new DecFieldX("bands", 8),
		new Hide(30+1),

		new Section("Set bands for thorax"),

		new Hide(32+1),
		new SelectNode(32),
		new SetIndex("height", 0),
		new DecFieldGroup("height"),
		new ToggleField("beginSP"),
		new ToggleField("endSP"),
		new IncFieldX("height",6),
		new IncFieldCtrlX("height",2),
		new SetIndex("height", 1),
		new DecFieldX("bands",2),
		new SetIndex("height", 3),
		new DecFieldGroup("height"),
		new DecFieldGroup("height"),
		new Hide(32+1),

		new Section("Set bands for pelvis"),

		new Hide(38+1),
		new SelectNode(38),
		new SetIndex("height", 4),
		new DecFieldGroup("height"),
		new DecFieldGroup("height"),
		new DecFieldGroup("height"),
		new ToggleField("endSP"),

		new Hide(32+1),
		new Hide(30+1),
		new Hide(28+1),
	};
	list+=EVENT_LIST(Build_flat_triangles_in_4_stagesArray);

	InputEvent* Add_blue_parts_for_sourceArray[]={
/*
		new Section("Half triangles for pelvis & thorax"),
		new MouseZoom(1.94),
		new DragViewPos(0,1,0),
		new SelectNode(38),
		new ToggleField("xJoinEnds"),
		new SetFieldValue("xDistance",".5"),
		//new SetFieldValue("slide",".5"),
		new DecFieldX("staves", 8),
		new SelectNode(32),
		new ToggleField("xJoinEnds"),
		new SetFieldValue("xDistance",".5"),
		//new SetFieldValue("slide",".5"),
		new DecFieldX("staves", 8),

		new Section("Copy missing halfs back"),
//		new MoveToNode(tummy0),
//		new MouseWheel(1),
		new Collapse(pelvis),
		new NewNodeAsSiblingAbove(COPYPART, 44),
		new UseNodeAsSource(38+1, 44),
		new UseNodeAsDest(38+1, 44),
		new SelectNode(44),
		new ToggleField("add"),
		new ToggleField("mirrorX"),
		new UseNodeAsSource(32+1, 44),
		new UseNodeAsDest(32+1, 44),
		new ClickButton(toggleWireFrame),
*/
		new Section("Add blue parts for source"),
		new NewNodeAsChild(IMMEDIATEPART, 1),
		new NewNodeAsChild(IMMEDIATEPART, 1),
		new NameNode(pelvisMap, "pelvisMap"),
		new NameNode(thoraxMap, "thoraxMap\n"),
		new UseNodeAsSource(thoraxMap, 34),
		new UseNodeAsSource(pelvisMap, 41),

		new Section("Copy poly map from white to blue parts"),
		new MouseZoom(.9),
		new DragViewPos(0,.5,0),
		new SelectNode(34),
		new ToggleField("store"),
		new ToggleField("xJoinEnds"),
		new MoveToNode(34),
		new RightClick,
		new Move_MenuItem(menu_copy_poly_map_to_source),
		new Click,

		new SelectNode(41),
		new ToggleField("store"),
		new ToggleField("southPole"),
		new MoveToNode(41),
		new RightClick,
		new Move_MenuItem(menu_copy_poly_map_to_source),
		new Click,

		new Section("Delete hole for arm join"),
new Hide(l_shoulder),
new SelectNode(37),
new ToggleField("polyMapAid"),

new SelectVertex(8,thoraxMap),
new ClickButton(cutLeftFromVertex),
	new MoveToExitSceneTree(),
	new Click(),
	new MoveToExitWindow(),
	new Click(),

new SelectVertex(31,thoraxMap),
new ClickButton(centerViewToControlPoint),
new MouseZoom(11.052095),
new DragViewPos(-.734796,-.24786,0),

new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
//////////
new SelectVertex(39,thoraxMap),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new SelectTriangle(191,thoraxMap),
new ClickButton(deleteTriangle),
new SelectTriangle(114,thoraxMap),
new ClickButton(deleteTriangle),

new TugVertex(31,1.173792,.219433,thoraxMap),
new TugVertex(39,1.153792,.617048,thoraxMap),
new TugVertex(48,.828792,.999663,thoraxMap),
new TugVertex(56,.168036,1.342278,thoraxMap),
new TugVertex(47,.143036,1.164663,thoraxMap),
new TugVertex(46,-.51772,.994663,thoraxMap),
new TugVertex(38,-.82272,.612048,thoraxMap),
new TugVertex(30,-.83772,.224433,thoraxMap),
new TugVertex(21,-.66272,-.088182,thoraxMap),
new TugVertex(13,.168036,-.585797,thoraxMap),
new TugVertex(22,.163036,-.378182,thoraxMap),
new TugVertex(23,.998792,-.088182,thoraxMap),
//new SelectTriangle(76,thoraxMap),
new ClickButton(splitTriangleImmediate),
new TugVertex(23,.660914,-.308182,thoraxMap),
new SelectTriangle(66,thoraxMap),
new ClickButton(swapDivide),
new SelectTriangle(70,thoraxMap),
new ClickButton(splitTriangleImmediate),
new TugVertex(22,-.314842,-.308182,thoraxMap),

new Section("Nurbs Surface Poly Editing (NSPE)"),
new MouseZoom(.627108),
new ClickButton(setLeftViewOrientation),
new SelectVertex(23,thorax),
new ClickButton(centerViewToControlPoint),
new ClickButton(setPolyEditMode),
new MouseZoom(10.04736),
new DragViewPos(-.225805,.857462,-.038944),

new SelectTriangle(191,thorax),
new ClickButton(swapDivide),
new SelectTriangle(150,thorax),
new ClickButton(swapDivide),
new SelectTriangle(114,thorax),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(78,thorax),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(65,thorax),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(108,thorax),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(216,thorax),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(234,thorax),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(190,thorax),
new ClickButton(splitTriangleImmediate),
new TugVertex(55,1.028217,.913434,thorax),
new SelectTriangle(184,thorax),
new ClickButton(splitTriangleImmediate),
new TugVertex(52,-.22958,.918623,thorax),
new SelectTriangle(361,thorax),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(367,thorax),
new ClickButton(splitTriangleImmediate),
new TugVertex(22,-.245304,-.452846,thorax),

new MouseZoom(6.794536),
new ClickButton(toggleWireFrame),
new DragViewRot(-.197445,-.967097,.160432,1.606139),
new DragViewRot(.192069,-.914494,.356105,2.401996),
new DragViewRot(.83082,-.523321,-.189404,.848113),
new ClickButton(openSceneTree),
new Hide(l_shoulder),


		new Section("Delete hole for leg join"),
new ClickButton(toggleWireFrame),
		new MouseZoom(1.317775),
new ClickButton(setFrontViewOrientation),
new DragViewPos(-.041369,.015738,0),
new MouseZoom(12.074657),
new SelectVertex(0,pelvisMap),
new ClickButton(cutLeftFromVertex),
new SelectNode(44),
new ToggleField("polyMapAid"),
new SelectNode(pelvisMap),

new MouseZoom(2.15023),
new DragViewPos(-.12043,1.126084,0, .5, -1.2),
new Hide(l_hip),
	new MoveToExitSceneTree(),
	new Click(),
	new MoveToExitWindow(),
	new Click(),
new DragViewRot(-.437005,-.810111,.390828,1.390058),
new SelectVertex(15,pelvis),
new ClickButton(centerViewToControlPoint),

new MouseZoom(11.955108),
new DragViewPos(-.085182,1.199623,-.033448),

/////////////
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new SelectVertex(22,pelvis),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new SelectVertex(14,pelvis),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new SelectVertex(5,pelvis),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new ClickButton(deleteTriangle),
new TugVertex(5,-.110508,-.49412,pelvis),
new ClickButton(joinVertexKeepDestColor),
new TugVertex(4,-.004993,-.611815,pelvis),
new TugVertex(5,.381594,-.68502,pelvis),
new TugVertex(11,.809304,-.576888,pelvis),
new TugVertex(18,1.401729,.097228,pelvis),
new TugVertex(26,1.298002,.895558,pelvis),
new TugVertex(25,.983864,1.134705,pelvis),
new TugVertex(24,.162739,1.106905,pelvis),
new TugVertex(17,-.222384,.806482,pelvis),
new TugVertex(16,-.431827,.4291,pelvis),
new TugVertex(10,-.479211,.032561,pelvis),
new SelectTriangle(56,pelvis),
new ClickButton(swapDivide),
new ClickButton(splitTriangleImmediate),
////////

new TugVertex(18,1.201779,-.270071,pelvis),
new SelectTriangle(24,pelvis),
new ClickButton(splitTriangleImmediate),
new TugVertex(10,-.312749,-.377096,pelvis),
new SelectTriangle(21,pelvis),
new ClickButton(swapDivide),
new SelectTriangle(116,pelvis),
new ClickButton(splitTriangleImmediate),
new TugVertex(27,.600196,1.210925,pelvis),
new SelectTriangle(119,pelvis),
new ClickButton(swapDivide),
new SelectTriangle(125,pelvis),
new ClickButton(swapDivide),
new SelectTriangle(83,pelvis),
new ClickButton(splitTriangleImmediate),
new TugVertex(29,1.439057,.509688,pelvis),
new SelectTriangle(69,pelvis),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(71,pelvis),
new ClickButton(swapDivide),
new TugVertex(24,-.69998,.306995,pelvis),
new SelectTriangle(108,pelvis),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(110,pelvis),
new ClickButton(swapDivide),
new DragViewRot(-.417297,-.905096,.081638,2.247836),
new SelectTriangle(194,pelvis),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(52,pelvis),
new ClickButton(swapDivide),
new SelectTriangle(126,pelvis),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(82,pelvis),
new ClickButton(swapDivide),
new SelectTriangle(84,pelvis),
new ClickButton(splitTriangleImmediate),
new SelectTriangle(55,pelvis),
new ClickButton(swapDivide),
new SelectTriangle(219,pelvis),
new ClickButton(swapDivide),
new DragViewRot(-.388324,-.836622,.386353,1.351051),
new ClickButton(toggleWireFrame),
new MouseZoom(2.128941),
new MoveToButton(openSceneTree),

new DragViewRot(-.392381,-.89532,.210806,.54084),
new ClickButton(openSceneTree),

new Hide(pelvisMap),
new Hide(thoraxMap),
new Hide(l_hip),


	};
	list+=EVENT_LIST(Add_blue_parts_for_sourceArray);
//transfer
	InputEvent* Modify_vertex_transfersArray[]={
		new Section("Fix torso, neck & head ownership"),
		new ClickButton(openOwnership),

		new Collapse(29),
		//new MoveToNode(48),
		//new RightClick,
		//new Move_MenuItem(menu_delete),
		//new Click,
		new Collapse(28),
		new Collapse(59),

		new Collapse(60),
		new MoveToNode(61),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new MoveToNode(61),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new MoveToNode(63),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new CopyNodeAsSiblingAbove(60, 66),

		new MoveToNode(65),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new MoveToNode(64),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new MoveToNode(63),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new MoveToNode(64),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new MoveToNode(64),
		new RightClick,
		new Move_MenuItem(menu_delete),
		new Click,
		new UseNodeAsSource(60+1, 60),
		new UseNodeAsSource(64+1, 64),


		new SelectNode(60),
		new ToggleField("beginSP"),
		new SetIndex("numOf", 0),
		new DecFieldX("numOf", 5),
		new SetIndex("numOf", 1),
		new DecFieldGroup("numOf"),
		new DecFieldGroup("numOf"),
		new DecFieldGroup("numOf"),
		new DecFieldGroup("numOf"),
		new DecFieldGroup("numOf"),

		new SelectNode(64),
		new ToggleField("beginSP"),
		new SetIndex("numOf", 0),
		new DecFieldGroup("numOf"),
		new DecFieldGroup("numOf"),
		new DecFieldGroup("numOf"),
		new DecFieldGroup("numOf"),

		//new ClickButton(toggleWireFrame),
		new MouseZoom(2.245635),
		new DragViewPos(.014894,1.048034,-.018853),
		new DragViewRot(.004318,-.999972,.006096,2.874718),
		new DragViewRot(.455537,.793607,-.403328,.404941),
	};
	list+=EVENT_LIST(Modify_vertex_transfersArray);

	InputEvent* Mirror_pelvis_and_thoraxArray[]={
		new Section("Mirror pelvis & thorax"),
		new NewNodeAsSiblingAbove(COPYPART, 69),

		new SelectNode(69),
		new ToggleField("add"),
		new ToggleField("mirrorX"),
		new UseNodeAsSource(pelvis, 69),
		new UseNodeAsDest(69+1, 69),
		new UseNodeAsSource(thorax, 69),
		new UseNodeAsDest(69+2, 69),


		new Section("Join vertical seams"),
		new ClickButton(toggleWireFrame),
		new Collapse(59),
		new NewNodeAsSiblingAbove(GROUPBUILD, 98),
		new SelectNode(98),
		new SetFieldValue("marker",".8 1 1"),
		new NewNodeAsChild(JOINVERTEX, 98),
		new UseNodeAsDest(pelvis, 99),
		new SelectNode(99),
		//new ToggleField("srcColor"),
		//new ToggleField("in"),
		new NewNodeAsChild(JOINVERTEX, 98),
		new UseNodeAsDest(thorax, 101),
		new SelectNode(101),
		//new ToggleField("srcColor"),
		//new ToggleField("in"),

		new Section("Join tummy to pelvis"),
		new NewNodeAsChild(JOINVERTEX, 98),
		new UseNodeAsSource(tummy0, 103),
		new UseNodeAsDest(pelvis, 103),
		new SelectNode(103),
		//new ToggleField("srcColor"),
		//new ToggleField("in"),

		new Section("Join thorax to tummy"),
		new NewNodeAsChild(JOINVERTEX, 98),
		new UseNodeAsSource(thorax, 106),
		new UseNodeAsDest(tummy1, 106),
		new SelectNode(106),
		//new ToggleField("srcColor"),
		//new ToggleField("in"),

		new Section("Join thorax to neck"),
		new NewNodeAsChild(JOINVERTEX, 98),
		new UseNodeAsSource(thorax, 109),
		new UseNodeAsDest(neck0, 109),
		new SelectNode(109),
		//new ToggleField("srcColor"),
		//new ToggleField("in"),
/////////

		new DragViewRot(-.142862,.970538,-.194025,1.832355),
		new MouseZoom(1.408306),

		new DragViewRot(-.126836,-.709118,.693588,.623368),
		new DragViewRot(-.126022,-.967149,.220775,3.602627),
		new DragViewRot(-.634004,.718425,.286189,5.446034),
	};
	list+=EVENT_LIST(Mirror_pelvis_and_thoraxArray);



	clickButton(saveSmls);
	list+=new Section(Complete);
}
