/* Seamless3d

Copyright (C) 2001-2017 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"
#include "robot_aid.h"

extern SettingsPtr g_settings;
extern ScenePtr g_scene;
bool g_writeWebGL = true;
//extern bool g_genNormals;
extern SelNode g_selNode;
void addEffectToList(M_<Effect*>& effectList, Effect* effect, String& str);
void genSkinPovTransforms(Art* part, Matrix parentMatrix, Matrix parentRotMatrix, int& smi, M_Matrix& m_matrix, M_Matrix& m_rotMatrix);
void setUpInternalEffectPtrs2(Art* part, Effect* lastEffect); //this (2) wont be needed when setUpInternalEffectPtrs is fixed
void resetCoordLen(M_Art& partList);
void extractFileName(String& filename, const String& path);
bool modifyVrmlX3dFilename(String& filename, bool writeX3DXML, bool writeX3DVRMLClassic);
extern bool g_removeFirstZero;

void exportWebGL(){
	ExportVrmlX3d* exportVrmlX3d = dynamic_cast<ExportVrmlX3d*>(g_scene->exportVrmlX3d.p);
	//Seamless* smls = dynamic_cast<Seamless*>(g_selNode.getRaw());
	//if(smls == 0){
	//	return;
	//}

	//modifyVrmlX3dFilename(filename, false, false);


	g_genColorIndex = false;
	g_genNormals = true;
	g_writeWebGL = true;
	g_removeFirstZero = false;

	static M_<Effect*> effectList;
	effectList.length = 0;

	g_writeGzipped = false;

	String str;

	String webGLFilename;
	extractFileName(webGLFilename, g_currentFilename);
	int len = webGLFilename.length - 1;
	webGLFilename = webGLFilename.substr(0, len);

	webGLFilename[len-3] = 'j';
	webGLFilename[len-2] = 's';
	webGLFilename[len-1] = 'o';
	webGLFilename += 'n';



	int vidx = 0;
	int vtidx = 0;
	//smls->outputToString(str, false);
	//smls->outObj(str, mtl, vidx, effectList, Matrix(), Matrix());
	g_scene->outWebGL(str, vidx, vtidx, effectList, Matrix(), Matrix());

	str.write(webGLFilename);
	g_writeGzipped = exportVrmlX3d->gZip;
	g_writeWebGL = false;
	g_genNormals = true;
	g_removeFirstZero = true;
}
/*
void IndexedFaceSet::toObjString(String& str){

	Coordinate* coord =dynamic_cast<Coordinate*>(this->coord.p);
	TextureCoordinate* texCoord =dynamic_cast<TextureCoordinate*>(this->texCoord.p);
	Normal* normal =dynamic_cast<Normal*>(this->normal.p);

	M_Vec3f point;
	M_Vec2f point2f;
	M_Vec3f vector;

	if(coord){
		point = coord->point;
		for(int i=0; i<point.length; i++){
			str+="v ";
			point[i].toString(str);
			str+='\n';
		}
	}
	if(texCoord){
		point2f = texCoord->point;
		for(int i=0; i<point2f.length; i++){
			str+="vt ";
			point2f[i].toString(str);
			str+='\n';
		}
	}
	//if(normal){
	//	vector = normal->vector;
	//	for(int i=0; i<vector.length; i++){
	//		str+="nv ";
	//		vector[i].toString(str);
	//		str+='\n';
	//	}
	//}

	//str+="s off\n";
	str+="usemtl Object\n";

//	if(vector.length == point.length){
		for(int i=0; i<coordIndex.length; i+=4){
			str+="f ";
			str+=coordIndex[i] + 1;
			str+='/';
			str+=texCoordIndex[i] + 1;
//			str+='/';
//			str+=coordIndex[i] + 1;
			str+=' ';
			str+=coordIndex[i+1] + 1;
			str+='/';
			str+=texCoordIndex[i+1] + 1;
//			str+='/';
//			str+=coordIndex[i+1] + 1;
			str+=' ';
			str+=coordIndex[i+2] + 1;
			str+='/';
			str+=texCoordIndex[i+2] + 1;
//			str+='/';
//			str+=coordIndex[i+2] + 1;
			str+='\n';
		}
//	}
//	else{
	//	for(int i=0; i<coordIndex.length; i+=4){
	//		str+="f ";
	//		str+=coordIndex[i] + 1;
	//		str+=' ';
	//		str+=coordIndex[i+1] + 1;
	//		str+=' ';
	//		str+=coordIndex[i+2] + 1;
	//		str+='\n';
	//	}
	//}
}
void Shape::toObjString(String& str){
	IndexedFaceSet* ifs = dynamic_cast<IndexedFaceSet*>(geometry.p);
	if(ifs==0)return;
	ifs->toObjString(str);
}
/*
void exportObj(){
	Seamless* smls = dynamic_cast<Seamless*>(g_selNode.getRaw());
	if(smls == 0){
		return;
	}

	String filename = g_settings->file;

	modifyFilename(filename, false, false, true, false, 0);


	String str;
	str += "mtllib imported_bikini.mtl\n";

	static M_<Effect*> effectList;
	effectList.length=0;
	smls->outObj(str, effectList, Matrix(), Matrix());

	g_writeGzipped=false;
	str.write(filename);
	g_writeGzipped=g_scene->outputGZipped;
}
*/

void outCoords(const M_Art& partList, int& smlsCoordLen, String& str){
	bool addComma = false;
	str += "\"coord\":[";
	for(int k = 0 ; k < partList.length; k++){

		Art* part = partList[k];

		//part->renderFromCoord=j;

		const M_Vec3f& coord = part->coord;
		smlsCoordLen += coord.length;


		if(part->coord.length){
			for(int idx = 0; idx < coord.length; idx++){
				Vec3f crd = coord[idx];
				if(addComma){
					str+=',';
				}
				addComma = true;
				str += crd.x;
				str+=',';
				str += crd.y;
				str+=',';
				str += crd.z;
			}
		}
	}
	str+="],\n";
}

void outNormals(const M_Art& partList, String& str){
	bool addComma = false;
	str += "\"normal\":[";
	for(int k = 0; k < partList.length; k++){

		Art* part=partList[k];

		const M_Vec3f& m_normal = part->normal;

		if(m_normal.length){
			for(int idx = 0; idx < m_normal.length; idx++){
				Vec3f nrm = m_normal[idx];
				if(addComma){
					str+=',';
				}
				addComma = true;
				str += nrm.x;
				str += ',';
				str += nrm.y;
				str += ',';
				str += nrm.z;
			}
		}
	}
	str+="],\n";
}

void outColors(const M_Color3f& m_color, int vertexCount, String& str){
	bool addComma = false;
	str += "\"color\":[";
	if(m_color.length >= vertexCount){
		
		for(int idx = 0; idx < m_color.length; idx++){
			Color3f color = m_color[idx];
			if(addComma){
				str+=',';
			}
			addComma = true;
			str += color.r;
			str += ',';
			str += color.g;
			str += ',';
			str += color.b;
		}
	}
	str+="],\n";
}

void Seamless::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	if(effect==0)return;



/*	addEffectToList(effectList, dynamic_cast<Effect*>(effect.p), str);
	for(int k=0; k<partList.length; k++){
		if(Effect* effect=dynamic_cast<Effect*>(partList[k]->effect.p)){
			addEffectToList(effectList, effect, str);
		}
	}
	*/
	str.requestMoreIfNeeded(4000000);

	const M_SArt& skeleton = this->skeleton;



/////////////////////////
	static Mesh* geomSource= new Mesh;

	if(partList.length==0 || partList[0]->workEffect==0)return;
	if(render==0 )return;
	int j=0;

	M_Int& coordIndex = geomSource->coordIndex.refValue();

	const_cast<Seamless*>(this)->catTranslationMatrix();
	geomSource->genTransformedNormals(partList);
	int coordLen=geomSource->coord.length;
	catMatrix();

//	addExtraCoordsRenderForGeomSource(coordIndex);

	int indexCount = coordIndex.length*3;

	if(!indexCount){
		return;
	}
	{
		coordLen=0;
		for(int k=0; k<partList.length; k++){
			coordLen+=partList[k]->coord.length;
		}
	}
//	str+="# coord ";
//	str+=coordLen;
//	str+="\n";
	int smlsCoordLen = 0;
	str+="{\n";
	outCoords(partList, smlsCoordLen, str);
	outNormals(partList, str);
//	setUpInternalEffectPtrs2(this);
	effect->outWebGL(partList, str, vidx, vtidx, coordLen, coordIndex);
	vidx += smlsCoordLen;
//	setUpInternalEffectPtrs(this);
	str+="}\n";
//	resetCoordLen( partList);
}
void MonoColorEffect::outWebGL(const M_Art& partList, String& str, int& vidx, int& vtidx, int vertexCount, M_Int& coordIndex)const{
}
void TextureEffect::outWebGL(const M_Art& partList, String& str, int& vidx, int& vtidx, int vertexCount, M_Int& coordIndex)const{

	const M_Vec2f& texCoord = this->texCoord;

	for(int i=0; i<texCoord.length; i++){
		str+="vt ";
		texCoord[i].toString(str);
		str+='\n';
	}
	//str+="s off\n";
	str+='\n';
	for(int t=0, k=0; k<partList.length; k++){
		Art* part=partList[k];
		M_Triangle& triangle=part->triangle;
		int triLen=triangle.length;
		if(part->show){
			for(int tr=0; tr < triLen; tr++){
				int idx = coordIndex[t++] + vidx;
				str+=idx;
				str+=',';
				str+=triangle[tr].ta + vtidx;
				str+=',';
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + vidx;
				str+=idx;
				str+='/';
				str+=triangle[tr].tb + vtidx;
				str+='/';
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + vidx;
				str+=idx;
				str+='/';
				str+=triangle[tr].tc + vtidx;
				str+='/';
				str+=idx;

				str+='\n';

			}
		}
		else{
			t+=triLen*3;
		}
	}
/*
	for(int t=0, k=0; k<partList.length; k++){
		Art* part=partList[k];
		M_Triangle& triangle=part->triangle;
		int triLen=triangle.length;
		if(part->show){
			for(int tr=0, i=triLen; --i>=0; ){
				str+="f ";
				int idx = coordIndex[t++] + 1;
				str+=idx;
				str+="//";
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + 1;
				str+=idx;
				str+="//";
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + 1;
				str+=idx;
				str+="//";
				str+=idx;

				str+='\n';

				tr++;
			}
		}
		else{
			t+=triLen*3;
		}
	}
	*/
	vtidx += texCoord.length;
}

void ColorEffect::outWebGL(const M_Art& partList, String& str, int& vidx, int& vtidx, int vertexCount, M_Int& coordIndex)const{
	outColors(color, vertexCount, str);

	bool addComma = false;
	str += "\"coordIndex\":[";

	for(int t = 0, k = 0; k < partList.length; k++){
		Art* part = partList[k];
		M_Triangle& triangle = part->triangle;
		int len = triangle.length * 3;
		if(part->show && len){
			for(int idx = 0; idx < len; idx++){
				if(addComma){
					str += ',';
				}
				addComma = true;
				str += coordIndex[t++] + vidx;
			}
		}
		else{
			t += len;
		}
	}
	str+="]\n";
}

void PovLight::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
}
void PovFog::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
}
void ModelMorpher::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
}
void Transform::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outPovRay(str, effectList, translationMatrix(-center) * rotationMatrix(-scaleOrientation) * scaleMatrix(scale) * rotationMatrix(scaleOrientation) * rotationMatrix(rotation) * translationMatrix(center) * translationMatrix(translation) * matrix,
				rotationMatrix(-scaleOrientation) * rotationMatrix(scaleOrientation) * rotationMatrix(rotation) * rotMatrix
			);
		}
	}
}
void Group::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outWebGL(str, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void LOD::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outWebGL(str, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
/*
void HAnimHumanoid::outWebGL(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& skeleton = this->skeleton.refValue();
	for(int k=0; k<skeleton.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(skeleton[k].p)){
			povRay->outPovRay(str, effectList, translationMatrix(-center) * rotationMatrix(-scaleOrientation) * scaleMatrix(scale) * rotationMatrix(scaleOrientation) * rotationMatrix(rotation) * translationMatrix(center) * translationMatrix(translation) * matrix,
				rotationMatrix(-scaleOrientation) * rotationMatrix(scaleOrientation) * rotationMatrix(rotation) * rotMatrix
			);
		}
	}
}
*/
void Switch::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outWebGL(str, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void Collision::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outWebGL(str, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void Anchor::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outWebGL(str, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void Billboard::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outWebGL(str, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void ProtoDeclare::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	M_Node& children=protoBody->children.refValue();
	for(int k=0;k<children.length;k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outWebGL(str, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
Matrix getViewMatrix();
void Scene::outWebGL(String& str, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();

	matrix=getViewMatrix();
	//rotationMatrix(rotation) * translationMatrix(translation) * matrix=scaleMatrix(scale);
	rotMatrix=rotationMatrix(rotation);

	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outWebGL(str, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
