/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

extern const char* title_message_from_thymes_code;
extern const char* str_OK;
extern const char* str_close_window;

Ptr<MessageWin>g_msg;

void closeMessageWindow(){
	Window::closeWindow(g_msg.p);
	removeTypeFromList<DownButton>(g_callBackList);
	removeTypeFromList<Button>(g_callBackList);
	g_msg=0;
}
void msg(String strA, String strB, String strC, unsigned dlgTypeAndIcon){

	String tempStr=String(strA);
	tempStr+=strB;
	tempStr+=strC;
	
	MessageWin* messageWin = new MessageWin();
	messageWin->m_button += new TextButton(str_OK, str_close_window, closeMessageWindow, *messageWin);
	
	messageWin->autoSizeAndStuff(tempStr);
	Window::topWindow = messageWin;

	if(dlgTypeAndIcon & ICONEXCLAMATION){
		PlaySound("SystemExclamation", 0, SND_ASYNC);
	}
}
void msg(String strA, unsigned dlgTypeAndIcon){
	msg(strA, "", "", dlgTypeAndIcon);
}
void MessageWin::autoSizeAndStuff(String i_msgA){
	str=i_msgA;
	g_msg=this;
	int greatestLength=0;
	int numOfLines=0;
	if(str.length){
		int i=0;
		int h=0;
		int linePos=title_bar_height+16;
		do{
			if(str[i]=='\n' || i == str.length-1){
				if(greatestLength < h){
					greatestLength = h;
					h = -1;
				}
				numOfLines++;
			}
			i++;
			h++;
		}while(i < str.length);
	}

	size = Vec2i(greatestLength*8 + 24, numOfLines*14 + title_bar_height + 50);
	pos = (g_3d->size >> 1) - (size >> 1);
	for(int i=m_button.length; --i>=0;){
		m_button[i]->dstPos=Vec2i((size.x >> 1) - 12, size.y-35);
	}
	paint();
}
void MessageWin::paint(){
	int* dstPix=pixBuf.getArray();

	blitHorizontalColorSweep(Vec2i(10, 0), Vec2i(470, 0), Vec2i(471, 0), Vec2i(size.x-9-10, title_bar_height));
	pasteSprite2( 0, 0, 461, 0, size.x, size.y, iconSrcBufCX, iconSrcBufCY, 10, title_bar_height, dstPix);
	pasteSprite2( size.x-9, 0, 471, 0, size.x, size.y, iconSrcBufCX, iconSrcBufCY, 9, title_bar_height, dstPix);

	drawText2(title_message_from_thymes_code, 0x0, Vec2i(8, 16), size.x, size.y, dstPix);

	paintSideEdge(&iconSrcBuf[(iconSrcBufCY-1-10)*480+444], 8, 0, title_bar_height, size.y-10, size.x, size.y, dstPix);
	paintSideEdge(&iconSrcBuf[(iconSrcBufCY-1-10)*480+452], 9, size.x-9, title_bar_height, size.y-10, size.x, size.y, dstPix);

	blitHorizontalColorSweep(Vec2i(8, size.y-10), Vec2i(451, 10), Vec2i(452, 10), Vec2i(size.x-8-9, 10));
	pasteSprite2( 0, size.y-10, 444, 10, size.x, size.y, iconSrcBufCX, iconSrcBufCY, 8, 10, dstPix);
	pasteSprite2( size.x-9, size.y-10, 452, 10, size.x, size.y, iconSrcBufCX, iconSrcBufCY, 9, 10, dstPix);

	paintBlock2(0xffffff, 8, title_bar_height, size.x-9, size.y-10, size.x, size.y, dstPix);

	if(str.length){
		int i=0;
		Button::str="";
		int linePos=title_bar_height+16;
		do{
			Button::str+=str[i];
			if(str[i]=='\n' || i == str.length - 1){
				drawText2(Button::str, 0x0, Vec2i(8, linePos), size.x, size.y, dstPix);
				Button::str="";
				linePos+=14;
			}
			i++;
		}while(i < str.length);
	}
	for(int i=m_button.length; --i>=0;){
		m_button[i]->paint();
	}

	if(g_settings->invertWindowColor){
		invert();
	}
	loadSurfaceFromMemory();
}
void MessageWin::buttonHover(Vec2i ptCursor){
	for(int k=m_button.length; --k>=0;){
		if(m_button[k]->initHover(ptCursor)){
			return;
		}
	}
}
