/* Seamless3d

Copyright (C) 2001-2013 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Complete;

#define NARATION 1

void InputEvent::preNurbsStitchedHeadDemo(){
	g_robotDemo->fileName="nurbs-stitched-head";
	g_robotDemo->function=InputEvent::nurbsStitchedHeadDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::nurbsStitchedHeadDemo(){

	const int seamless = 1;
	const int pelvis = 3;

	InputEvent* array0[]={

		new Section("Head list"),
		new DemoSound("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\head-modelling-intro.wav"),
		new DragViewRot(0, -1, 0, PI*.5, -1.428125,-.65625),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\carpet-snake.smls"),
		new Wait(1),
		new DragViewRot(.747214, -.318272, -.583416, .854158, -1.428125,-.65625),
		//new DragViewRot(.790684,-.483247,-.375888,.936226, -1.428125,-.65625),
		new Wait(1),
		new Section(Complete),


		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141018-art-head-cage.smls"),
		new Wait(1),
		new DragViewRot(.439607, -.893238, .094191, -5.819834,-1.428125,-.65625),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141018-art-head.smls"),
		
		new Wait(.25),
		new DragViewRot(.002536,-.997449,-.071341,5.644055,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(1,0,0,0,-1.428125,-.65625),
		new Wait(.25),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\140922-lucy-grace-kelly-nose-makeup-cage.smls"),
		new Wait(.25),
		new DragViewRot(0,1,0,PI*.5,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(1,0,0,0,-1.428125,-.65625),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\140922-lucy-grace-kelly-nose-makeup.smls"),
		new Wait(.25),
		new DragViewRot(.174997,-.98455,-.006171,.8659,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(1,0,0,0,-1.428125,-.65625),
		//new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141005-lucy-petra-nemcova-nose-15-mm-eyes.smls"),
		new Wait(.25),

		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\140922-lucy-grace-kelly-nose-makeup-show-eyeballs.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141015-grace-kelly-nose-15-mm-eyes-makeup-show-eyeballs.smls"),
		new Wait(1),
		new Section("Small eyes"),
		new DemoSound("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\small-eyeball.wav"),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141015-grace-kelly-nose-15-mm-eyes-makeup.smls"),
		new Wait(.25),
		new DragViewRot(.396074,-.70201,-.591868,.356936,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(.169835,-.980793,-.095923,.970923,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(.740324,.391047,-.546811,.241108,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(-.99993,-.001109,.011781,4.899005,-1.428125,-.65625),
		new Wait(.25),
		//new DragViewRot(-.378301,.910108,.169089,.601006,-1.428125,-.65625),
		new DragViewRot(-.758111,-.531172,.378318,1.264299,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(-.970983,.198657,-.133147,.879518,-1.428125,-.65625),
		new Wait(.25),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\140922-lucy-grace-kelly-nose-makeup-angle-cheeks.smls"),
		new Wait(4),
		//new DragViewRot(-.970983,.198657,-.133147,.879518,-1.428125,-.65625),
		new DragViewRot(1,0,0,0,-1.428125,-.65625),
		new Wait(.25),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141015-grace-kelly-nose-15-mm-eyes-makeup.smls"),
		new Wait(.25),
		new DragViewRot(-.999593,-.011177,-.026265,1.030034,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(.389208,-.920642,-.03059,.69421,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(.206576,.937934,-.278578,.673963,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(1,0,0,0,-1.428125,-.65625),
		new Wait(.25),


		new Section("eyes-closer"),
		new DemoSound("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\eyes-closer.wav"),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141015-grace-kelly-nose-eyes-closer-thinner-nose.smls"),
		new Wait(.25),
		new DragViewRot(-.991016,-.128364,-.037558,.936968,-1.428125,-.65625),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141015-grace-kelly-nose-eyes-closer-thinner-and-flatter-nose.smls"),
		new Wait(.25),
		new DragViewRot(1,0,0,0,-1.428125,-.65625),
		new Wait(.25),

		new Section("Scale-up"),
		new DemoSound("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\scale-up.wav"),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141015-grace-kelly-nose-eyes-closer-thinner-and-flatter-nose-wider-head.smls"),
		new Wait(3),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141015-grace-kelly-nose-eyes-closer-thinner-and-flatter-nose-rounder-head.smls"),
		new Wait(2),
		new DragViewRot(-.409566,.843262,-.348087,1.328883,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(1,0,0,0,-1.428125,-.65625),
		new Wait(.25),

		new Section("Increase-ear-distance"),
		new DemoSound("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\theory.wav"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\140922-lucy-grace-kelly-nose-makeup.smls"),
		new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\140922-lucy-grace-kelly-nose-makeup-increase-distance.smls"),
		new Wait(3),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\140922-lucy-grace-kelly-nose-makeup-rounder-head.smls"),
		new Wait(2),
		new DragViewRot(-.991016,-.128364,-.037558,.936968,-1.428125,-.65625),
		//new DragViewRot(-.409566,.843262,-.348087,1.328883,-1.428125,-.65625),
		//new Wait(.25),
		//new DragViewRot(1,0,0,0,-1.428125,-.65625),
		//new Wait(.25),
		//new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\head-list\\141015-grace-kelly-nose-15-mm-eyes-makeup.smls"),
		//new Wait(.25),
		//new DragViewRot(.389208,-.920642,-.03059,.69421,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(-.028949,-.997901,.057936,.849422,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(.206576,.937934,-.278578,.673963,-1.428125,-.65625),
		new Wait(.25),
		new DragViewRot(1,0,0,0,-1.428125,-.65625),
		new Wait(.25),
		

		new Section(Complete),

		new Section("Show diversion"),

#if NARATION
	//new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\winter-2014-vlog\\stills\\short-yawn.wav"),
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\winter-2014-vlog\\diversion\\divert-line-mono-4100.wav"),
	
#endif

		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\patch.smls"),
		new ClickButton(insertControlPoint),
		new SelNurbsLine(55,66,.98684),
		new DemoMove(-.84375,.16875),
		new Wait(2.5),
		new SelNurbsLine(60,62,.5),
		new ToggleField("done"),
new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\patch.smls"),
new ClickButton(insertControlPoint),

new SelNurbsLine(76,87,.004201),
new SelNurbsLine(60,62,.5),
new ToggleField("done"),

new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\patch.smls"),
		new ClickButton(insertControlPoint),
		new SelNurbsLine(55,66,.98684),
		new Wait(1),
		new DemoMove(.9125,.15),
		new Wait(2.5),
		new ToggleField("done"),

new Wait(1),
new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\patch.smls"),
new ClickButton(insertControlPoint),
new SelNurbsLine(60,71,.917395),
new Wait(3),
new DemoMove(.165625,.140625),
new Wait(1),
new SelNurbsLine(60,62,.5),
new ToggleField("done"),

new Wait(1),

new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\patch.smls"),
new ClickButton(insertControlPoint),
new SelNurbsLine(59,60,.131944),
new Wait(1),
new DemoMove(-.141667,.164583),
new SelNurbsLine(60,82,.5),
new ToggleField("done"),
new Wait(4),

new Section(Complete),
////////////////////////////////////
//new ClickButton(openGridControl),
//new ToggleField("show"),
//new MoveToExitWindow(),
//new Click(),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\140607-simple-thyme-type-head-b.smls"),

new ClickButton(insertControlPoint),

new SelNurbsLine(596,619,.894565),
new SelNurbsLine(592,594,.5),
new SelNurbsLine(548,594,.5),
new ToggleField("done"),

new TugCP(515,0,-.05026),
new ClickButton(centerViewToControlPoint),

new MouseZoom(4.594974,.253125,1.021875),
new DragViewRot(.137102,.990557,-.000634,1.013496,.253125,1.021875),
new TugCP(515,.238524,-.144027),
new TugCP(1046,.498373,-.148098),
new TugCP(513,-.093679,-.167621),
new TugCP(1048,-.057359,-.161866),
new DragViewRot(-.870475,.286152,-.400488,1.089306,-.057359,-.161866),
new TugCP(1048,-.245643,.304473),
new TugCP(1052,-.261045,.025563),
new TugCP(513,-.154107,.166322),
new ClickButton(extrudePatch),
new DecFieldX("distance", 5),
new ToggleField("done"),

//new Section("Show diversion2"),

new DragViewRot(-.623165,.269744,-.734101,.613746,-1.609375,.55625),
new ClickButton(selectRing),

new SelNurbsLine(1077,1078,.024721),
new DragViewRot(.136898,.117397,-.983604,.093458,-.24249,-.120357),
new TugCP(1076,-.24249,-.120357),

//new Section("Show diversion3"),
new TugCP(1061,-.02058,-.230913),
new TugCP(509,-.012772,-.175206),
new DragViewRot(-.004495,.994863,.101126,1.484423),
new TugCP(1040,.008761,-.26687),
new DragViewRot(-.145387,-.955573,-.256403,.446578),
new MouseZoom(1.61051),
new DragViewRot(.097824,-.116896,-.988315,.215357),


new ClickButton(insertControlPoint),

new SelNurbsLine(1019,1034,.066079),
new SelNurbsLine(747,494,.5),
new SelNurbsLine(761,379,.5),
new DragViewRot(-.186588,-.961614,-.201206,.810395),
new SelNurbsLine(925,933,.5),
new ToggleField("done"),


//new Section("Show diversion4"),


new ClickButton(insertControlPoint),

new SelNurbsLine(404,405,.847237),
new SelNurbsLine(316, 331,.5),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(347,362,.961799),
new SelNurbsLine(1007,201,.5),
new DragViewRot(-.005741,-.991656,-.128781,2.231024, 1.35,-.2875),
//new SelNurbsLine(378,376,.5),
//new SelNurbsLine(378,376,.5),
new SelNurbsLine(994,1005,.5),
new ToggleField("done"),
new DragViewRot(-.127483,-.694362,-.708244,.389071,-1.621875,.9125),

new Wait(2),





//new Section("Show diversion2"),
//
//new DragViewRot(.154277,-.986773,-.049784,1.179499,-1.703125,.6),
//new TugCP(1046,-.688531,-.092321),
//new TugCP(515,-.586472,-.122795),
//new TugCP(517,-.516572,-.139308),
//new TugCP(1044,-.544213,-.107375),
//new DragViewRot(-.966972,.013015,.254551,.845289,-.544213,-.107375),
//new MouseZoom(2.143589),
//new TugCP(1048,-.268801,.741582),
//new TugCP(1052,-.17243,.622102),
//new DragViewRot(-.50922,.732725,.451452,1.242477,-.17243,.622102),
//new TugCP(515,.711328,.740537),
//new TugCP(513,.577849,.651492),
//new ClickButton(extrudePatch),
//
//new DecFieldX("distance",4),
//new ToggleField("done"),
//
//new DragViewRot(-.502977,-.042485,.863255,.235484,-1.703125,.6),
//
//new Section("Show diversion2"),
//new MouseZoom(1.4641,-1.703125,.6),
//new DragViewRot(.19299,-.974026,.118437,.755966,-1.703125,.6),
//new MouseZoom(1.331,-1.703125,.6),
//new DragViewRot(.014333,-.982699,.184656,.586203,-1.703125,.6),
//new ClickButton(insertControlPoint),
//
//new SelNurbsLine(924,925,.244648),
//new SelNurbsLine(761,379,.5),
//new SelNurbsLine(834,832,.5),
//new ToggleField("done"),
//
//new Section("Show diversion3"),
//new DragViewRot(-.897452,-.367769,.243569,.680084,-1.703125,.6),
//new TugCP(1074,-.072563,.383709),
//new ClickButton(centerViewToControlPoint),
//new MouseZoom(4.594974),
//new RectVert(-.16875,-.04375,.0625,-.3),
//new TugCP(1151,-.007746,-.24709),
//
//new MouseZoom(1.331),
//new DragViewRot(.351329,.932722,.081226,.370093),
//new DragViewPos(-.081201,-.294058,-.486844,.83125,.340625),
//new ClickButton(setHomeMode),
//
//new Section("Show diversion4"),

new Wait(2),
new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\amy-edit-head.smls"),
new Wait(1),
new DragViewRot(.068133,.990306,-.121049,.4891, -1.7125,.753125),
new Wait(1),
new DragViewRot(.761008,.641537,.096421,.547755, -1.7125,.753125),
new Wait(1),
new DragViewRot(.423006,-.8173,.391263,.63638, -1.7125,.753125),
new Wait(2),

		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\patch.smls"),

new ClickButton(insertControlPoint),

new SelNurbsLine(107,108,.385417),
new SelNurbsLine(84,106,.5),
new SelNurbsLine(78,80,.5),
new SelNurbsLine(14,36,.5),
new SelNurbsLine(40,42,.5),
new SelNurbsLine(40,62,.5),
new SelNurbsLine(58,60,.5),
new SelNurbsLine(60,82,.5),
new ToggleField("done"),


new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\box.smls"),
new ClickButton(insertControlPoint),
new SelNurbsLine(116,129,.781713),
new SelNurbsLine(112,114,.5),
new SelNurbsLine(88,114,.5),
new ToggleField("done"),

new RectVert(-.63125,-.29375,.3375,-.408333),
new ClickButton(setLeftViewOrientation),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.742708,-.189583,0)),
new TugCP(142,-.783827,-.221377),
new DragViewRot(.278017,-.95788,-.071921,.232533),

new Wait(2),
//		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\140607-simple-thyme-type-head.smls"),
//new ClickButton(insertControlPoint),
//new SelNurbsLine(299,326,.180976),
//new SelNurbsLine(623, 415,.5),
//new SelNurbsLine(611,564,.5),
//new ToggleField("done"),
//
//new Wait(2),
//		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\140607-simple-thyme-type-head.smls"),
//new DragViewRot(-.032091,.99795,.05538,.993235),
//new ClickButton(insertControlPoint),
//new SelNurbsLine(326,353,.675453),
//new SelNurbsLine(765, 277,.5),
//new DragViewRot(.071339,.965035,.252227,2.519457),
//new SelNurbsLine(763,34,.5),
//new DragViewRot(.283177,.865667,.412833,3.276512),
//new ToggleField("done"),
//
//new Wait(2),
//		new ShowFile("C:\\Users\\thyme\\Documents\\winter-2014-vlog\\140607-simple-thyme-type-head.smls"),
//new DragViewRot(-.306669,-.947641,.089047,1.023429),
//new ClickButton(insertControlPoint),
//new SelNurbsLine(842,843,.880981),
//new SelNurbsLine(334,332,.5),
//new DragViewRot(-.828468,-.096956,.55158,.263101),
////new DragViewRot(-.443873,.877633,-.180933,.240914),
//new SelNurbsLine(686, 568,.5),
//new ToggleField("done"),


new Section("Set birds eyes view"),


new ClickButton(setBirdsEyeViewOrientation),
new Section("Add nurbs lathe"),
	new Wait(2.5),
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\make-sure-mirror-state.wav"),
	new MoveToButton(toggleCreateMirrorObjectMode),
#endif


#if NARATION
	new Wait(7),
new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\set-lathe-position.wav"),
#endif
new ClickButton(buildNurbsLatheForSelPart),
new AddCtrlPnt(0,0),

#if NARATION
new Wait(14),
new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\set-spindle-orientation.wav"),
#endif
new AddCtrlPnt(0,.5),

#if NARATION
new Wait(4),
new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\add-control-points.wav"),
#endif
new AddCtrlPnt(.124452,-.377634),
new AddCtrlPnt(.250144,-.374226),
new AddCtrlPnt(.368747,-.33349),
new AddCtrlPnt(.446694,-.252706),
new AddCtrlPnt(.486952,-.129206),
new AddCtrlPnt(.507869,.002181),
new AddCtrlPnt(.500149,.368431),
new AddCtrlPnt(.501717,.74516),


new ToggleField("done"),

new ClickButton(setFrontViewOrientation),
#if NARATION
new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\right-drag-view.wav"),
#endif

new DragViewRot(.980665,-.195405,.010644,.268919),
new DragViewRot(.980665,-.195405,.010644,.268919, -.03125,-.159375),


new Section("Convert to patch"),
#if NARATION
new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\convert-to-patch.wav"),
new Wait(8),
#endif

new ClickButton(convertToPatch),

#if NARATION
new Wait(2),
#endif

new IncFieldX("control_staves", 5),

#if NARATION
new Wait(2),
#endif

new ToggleField("done"),


new DragViewRot(.799235,-.597324,.066543,.340692, -1.584375,-.003125),
//new Section("Toggle backface select"),
//new ClickButton(toggleBackfaceSelect),

new Section("Extrude 2 holes for the eyes"),
new ClickButton(setFrontViewOrientation),

new ClickButton(selectRing),

new SelNurbsLine(8,9,.006679),

new Scale1d(1,0,.076497),

new Scale1d(0,.844894,0),
new ClickButton(selectRing),

new SelNurbsLine(26,27,.997872),

//new Scale1d(1,0,.139003),
new Scale1d(1,0,.213846),
new ClickButton(selectRing),

new SelNurbsLine(65,66,.267387),

new Scale1d(1,0,.329439),
new ClickButton(setLeftViewOrientation),

new RectVert(-.184375,.634375,.928126,-.132292),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.263542,.005208,0)),

new Scale1d(1,.263542,.918963),
new ClickButton(setFrontViewOrientation),

new TugCP(102,-.305557,.364148),

new DragViewRot(.732587,.680628,.007872,.236418),

new ClickButton(extrudePatch),

new DecFieldX("distance", 11),

new ClickButton(insertControlPoint),
new SelNurbsLine(120,121,.062283),
new ToggleField("done"),
new ClickButton(setFrontViewOrientation),


new Section("Shape face"),
new ClickButton(toggleBackfaceSelect),
new ClickButton(setFrontViewOrientation),

new RectVert(-.5,.546875,-.370833,.403125),
new TugCP(30,-.55697,.510934),
//new TugCP(30,-.55697,.510934),
new TugCP(30,-.495807,.508265),
new RectVert(-.365625,.428125,-.292708,.315625),
new TugCP(336,-.426862,.418454),
new RectVert(-.390625,.828125,-.296875,.648958),
new TugCP(32,-.349762,.896151),
new RectVert(-.434375,.2625,-.338542,.166667),
new TugCP(327,-.416624,.297801),
new RectVert(-.603125,-.0125,.894792,-.63125),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.017708,-.001042,0)),

new Scale1d(1,.017708,.309429),
new DragViewRot(.210678,-.977521,.008162,.85921),
new TugCP(34,-.19435,.690185),
new TugCP(36,.051979,.59686),
new ClickButton(toggleBackfaceSelect),

new DragViewRot(.345145,-.93068,-.12128,1.281378),
new DragViewRot(.507007,.646331,-.570264,.982939),

new Section("Insert line from back of neck to eye"),

new ClickButton(insertControlPoint),

new SelNurbsLine(144,145,.016145),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(351,352,.931222),
new ToggleField("done"),

new Section("Insert line from eye to eye"),
new ClickButton(insertControlPoint),

new SelNurbsLine(395,396,.045677),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(404,405,.936363),
new ToggleField("done"),
new ClickButton(setFrontViewOrientation),

new Section("Shape face 3"),

new TugCP(413,-.14877,.332379),
new TugCP(411,-.201588,.26347),
new TugCP(417,-.171492,.473453),
new TugCP(436,-.177462,.46548),
new TugCP(432,-.15474,.341072),
new TugCP(430,-.186724,.292996),
new TugCP(411,-.180754,.280136),
new TugCP(434,-.143884,.403808),
new TugCP(242,0,.320746),
new RectVert(-.4625,.38125,-.36875,.329167),
new TugCP(442,-.439578,.343099),
new RectVert(-.453125,.471875,-.401042,.392708),
new TugCP(421,-.441727,.455595),
new TugCP(425,-.404124,.264468),
new TugCP(409,-.276533,.239798),
new TugCP(428,-.274169,.248491),
new ClickButton(toggleBackfaceSelect),

new RectVert(-.421875,.98125,-.323958,.845832),
new TugCP(197,-.405696,.768147),
new RectVert(-.221875,.984375,-.146875,.876041),
new TugCP(199,-.230589,.932189),
new RectVert(-.340625,.578125,-.257292,.448958),
new TugCP(438,-.331264,.505868),
new RectVert(-.221875,.51875,-.144792,.445833),
new TugCP(417,-.196492,.494287),
new RectVert(-.19375,.359375,-.125,.313542),
new TugCP(432,-.138073,.357739),
new RectVert(-.165625,.459375,-.107292,.390625),
new TugCP(415,-.125414,.428448),
new DragViewRot(.333843,-.919642,-.206901,.867805),
new ClickButton(toggleBackfaceSelect),

new Section("Shape face 4"),

new MouseZoom(3.138429),
new ClickButton(setFrontViewOrientation),

new RectVert(-.390625,.31875,.559375,-.379166),
new TugCP(277,-.687427,-.02763),
new TugCP(302,-.747747,.040331),
new TugCP(300,-.731843,-.052516),

new RectVert(-.3875,.43125,.372916,-.35),
new ClickButton(setLeftViewOrientation),

new TugCP(318,-1.491147,-.213896),
new DragViewRot(.038227,-.998515,-.038826,1.236713),
new RectVert(-1.028125,.284375,-.928125,-.059375),
new DragViewRot(.070783,-.994653,-.075199,.97463),
new RectVert(-.78125,.26875,-.620831,-.058333),
new ClickButton(setLeftViewOrientation),

new TugCP(312,-1.366145,.257051),
new DragViewRot(.732858,.446873,-.513053,.159862),




new ClickButton(setFrontViewOrientation),

new ClickButton(insertControlPoint),

new SelNurbsLine(308,331,.599382),
new ToggleField("done"),

new Section("Shape face 5"),

new RectVert(-.78125,.084375,-.618748,-.101042),
new ClickButton(setRightViewOrientation),

new TugCP(300,1.124476,-.065016),
new ClickButton(setFrontViewOrientation),

new RectVert(-.7125,.040625,-.641666,-.065625),
new ClickButton(setRightViewOrientation),

//new TugCP(277,1.043504,-.060963),
new TugCP(277,1.076838,-.052631),
new ClickButton(setFrontViewOrientation),

new DragViewRot(.248828,-.968512,.008372,.584248),
new ClickButton(insertControlPoint),

new SelNurbsLine(285,308,.158734),
new ToggleField("done"),
new ClickButton(selectRing),

new SelNurbsLine(285,286,.367318),
new ClickButton(setLeftViewOrientation),

new TugCP(287,-1.260174,.026182),

new Section("Shape face 6"),



new ClickButton(setLeftViewOrientation),

new DragViewRot(.094643,-.954856,-.281589,.557193),
new ClickButton(insertControlPoint),

new SelNurbsLine(275,298,.443297),
new ToggleField("done"),
new ClickButton(selectRing),

new SelNurbsLine(306,307,.947289),
new ClickButton(setFrontViewOrientation),

new ClickButton(setSingleActiveMode),

new TugCP(308,0,.010589),
new TugCP(310,.245524,.011813),
new TugCP(312,.466623,-.001429),
new TugCP(318,.24385,-.020094),
new TugCP(300,-.682637,-.034202),
new DragViewRot(.018861,-.999822,-.000965,1.677434),
new DragViewRot(-.69536,-.484061,.531187,2.171147),
new TugCP(316,-.880224,.844371),
new TugCP(314,-.876776,.843007),
new ClickButton(selectRing),
new SelNurbsLine(288,289,.031322),
new TugCP(293,-.803887,.859428),
new TugCP(291,-.799649,.860041),

new DragViewRot(.019537,-.990755,-.134251,.564071),
new DragViewRot(.250993,-.942656,-.220005,.520508),
new TugCP(402,-.425447,.140267),
new TugCP(404,-.151664,.023838),
new TugCP(448,-.308881,.284863),
new Section("Shape face 7"),
new ClickButton(setLeftViewOrientation),

new TugCP(482,-1.296634,-.478882),
new TugCP(225,-1.338931,-.675916),
new TugCP(32,-1.130501,-.875203),
new TugCP(94,-.630652,-.965965),
new DragViewRot(.601257,-.055538,-.797124,.362556),
new ClickButton(setFrontViewOrientation),

new TugCP(436,-.34397,-.33558),
new TugCP(390,-.302405,-.28473),
new TugCP(390,-.302405,-.28473),
new TugCP(396,-.518078,.203844),
new TugCP(398,-.289781,.298136),
new TugCP(400,0,.319812),
new Section("Shape face 8"),

new ClickButton(setFrontViewOrientation),

new DragViewRot(.026683,.999628,.005734,1.221159),
new ClickButton(setHomeMode),

new DragViewRot(.057743,-.998164,.018269,1.497946),
new ClickButton(setModellingMode),

new TugCP(454,-1.032561,-.227656),
new TugCP(408,-1.028983,-.174343),
new ClickButton(setHomeMode),

new DragViewRot(-.928197,.270487,-.255512,1.080299),
new DragViewPos(-.026164,-.182961,-.31537,-.084375,.575),
new DragViewRot(-.468912,-.698253,.540893,1.094687),
new ClickButton(setModellingMode),

new TugCP(360,.432306,.016942),
new TugCP(406,.431338,.092749),
new TugCP(452,.488243,.20776),
new DragViewRot(-.758933,-.092837,.644517,1.45282),
new ClickButton(setHomeMode),

new DragViewRot(-.393551,.586506,-.707904,.679432),
new ClickButton(setModellingMode),

new DragViewRot(.508113,-.498516,-.702355,.85611),
new DragViewRot(.786813,-.317143,-.529477,1.280236),
new MouseZoom(4.177249),
new TugCP(348,-1.092324,.354868),
new TugCP(346,-1.089135,.349402),
new DragViewRot(.769982,.056366,-.635571,.451286),
new MouseZoom(2.593743),
new ClickButton(setHomeMode),

new DragViewRot(-.968102,.06454,-.242103,.919737),
new ClickButton(setModellingMode),

new TugCP(396,-.544874,.153966),
new TugCP(350,-.537212,.08558),
new TugCP(394,-.735531,.002046),
new DragViewRot(.413897,-.603282,-.681718,.835477),
new ClickButton(setHomeMode),

new DragViewRot(.517609,-.829602,-.209383,.594394),

new Section("prepare nose for extruding nostrils"),

new ClickButton(setModellingMode),

new MouseZoom(2.143589),
new DragViewRot(.706972,.288631,-.645665,.35588),
new ClickButton(setFrontViewOrientation),

new TugCP(444,-.283135,-.124821),
new TugCP(446,-.056085,-.104955),
new TugCP(450,.364056,-.223567),

new Section("Extrude nostrils"),

new ClickButton(setFrontViewOrientation),

new DragViewRot(.118436,-.98267,-.142595,1.415558),
new TugCP(492,-.368466,.071115),
new TugCP(494,-.298075,-.028929),
new TugCP(496,-.181214,-.184466),
new DragViewRot(-.138738,.518656,-.843652,.310035),
new DragViewRot(-.600167,.380354,-.703655,.38666),
new TugCP(490,-.147963,.179241),
new TugCP(444,-.182968,.00944),
new TugCP(488,-.337035,.152944),
new TugCP(442,-.363591,-.014954),
new ClickButton(insertControlPoint),

new SelNurbsLine(446,469,.91741),
new ToggleField("done"),
new Section("Extrude nostrils 2"),

new TugCP(490,-.16619,.090824),
new ClickButton(extrudePatch),

new DecFieldX("distance", 5),
new TugCP(306,-.135463,.258408),
new TugCP(308,.055989,.250525),
new DragViewRot(-.088821,-.965434,-.245049,1.51556),
new ClickButton(toggleZBufferCageMode),



new Section("Extrude nostrils 3"),

new TugCP(312,-.200595,.010804),
new TugCP(310,-.225219,.208137),
new DragViewRot(-.429981,-.880209,-.200869,1.216541),
new TugCP(312,.032535,.053911),
new TugCP(359,-.047655,.005623),
new ClickButton(toggleZBufferCageMode),

new DragViewRot(.568792,.61383,-.547437,.122138),
new TugCP(582,.306403,-.219987),
new DragViewRot(.996426,.024533,-.080827,.637932),
new TugCP(312,.32401,-.088429),
new TugCP(359,.298773,-.19474),
new DragViewRot(.893261,-.20859,-.398216,1.31231),
new TugCP(393,-.774014,.236886),
new TugCP(391,-.765354,.165817),
new DragViewRot(.122296,-.991706,-.039529,1.378549),
new TugCP(353,-.118947,-.699336),
new ClickButton(setHomeMode),

new DragViewRot(.570648,.611823,-.547753,1.636286),
new DragViewRot(-.9756,-.209301,.066316,.513393),
new ClickButton(setModellingMode),

new DragViewRot(.99015,.110275,-.086273,.743838),
new ClickButton(insertControlPoint),

new SelNurbsLine(616,635,.118762),
new ToggleField("done"),
new DragViewRot(.026786,-.999184,-.030214,1.424835),
new TugCP(730,.101883,.16787),
new TugCP(736,.273611,.825526),
new TugCP(738,.37974,.806782),
new DragViewRot(-.49315,-.723647,.482844,1.577765),
new DragViewPos(-.36818,-.346958,-.197229,-.26875,.7),
new TugCP(740,.072428,.344813),
new DragViewRot(-.582212,-.539298,.60843,1.611451),
new TugCP(742,.11038,.247542),
new DragViewRot(-.522704,-.270126,.808587,1.427651),
new TugCP(744,.189315,.093313),
new DragViewRot(.110842,-.974771,-.193744,1.548914),
new TugCP(728,-.210071,-.158315),
new DragViewRot(.508263,-.126102,-.85192,.779942),
new TugCP(730,-.58173,.200457),
new TugCP(734,-.33205,.534127),
new TugCP(732,-.522805,.31196),
new DragViewRot(-.504247,-.446354,-.739259,.759151),


new Section("DO NECK"),
new ClickButton(setLeftViewOrientation),

new MouseZoom(1),
new ClickButton(toggleBackfaceSelect),

new ClickButton(setSingleActiveMode),

new RectVert(-.79375,.709375,.125,-.74896),
new TugCP(56,-.148643,-.195152),
new RectVert(-1.01875,.103125,-.929166,-.076042),
new RectVert(-.340625,.446875,.028125,-.180208),
new TugCP(54,-.173643,.030347),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.283333,-.080208,0)),

new Rotate(0,.211458,-.022917),
new Section("extrude ears"),


new DragViewRot(.431035,-.839785,-.330106,.897493),
new ClickButton(toggleBackfaceSelect),

new TugCP(116,.244585,-.013922),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("distance",17),
new IncFieldX("insertions"),
new ClickButton(insertControlPoint),

new SelNurbsLine(987,988,.07095),
new ToggleField("done"),
new ClickButton(setLeftViewOrientation),

new TugCP(136,-.156746,.562874),
new TugCP(138,-.120285,.520376),
new TugCP(140,-.05468,.415341),
new RectVert(-.08125,.26875,.447916,-.2875),

new Scale1d(1,.170511,.821973),
new TugCP(1038,.522598,.023686),
new RectVert(.2,.1625,.275,.075),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.158333,.197917,0)),
new TugCP(1012,.213287,.141495),
new TugCP(142,.106996,.251186),
//new TugCP(170,.33691,.430356),
//new TugCP(168,.31191,.591626),
//new TugCP(166,.320244,.673934),
new TugCP(32,.082327,-.674582),
new TugCP(58,.336494,-.529266),
new TugCP(56,.486494,-.290695),
new ClickButton(selectRing),

new SelNurbsLine(87,88,.80772),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.942708,-.667708,0)),

new Scale1d(1,.942708,-.377893),

new Rotate(1,1.818755,-.683333),
new TugCP(83,.578195,-.846813),

new Section("DO NECK 2"),

new RectVert(.85,-.153125,.541665,.771877),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.498958,-.264583,0)),

new Rotate(1,.935606,-.079043),
new ClickButton(insertControlPoint),

new SelNurbsLine(166,181,.853859),
new ToggleField("done"),
new TugCP(196,.834049,.557943),
new TugCP(198,.74882,.471974),
new TugCP(200,.659918,.350534),
new TugCP(202,.544175,.209773),
new TugCP(166,.286908,.757266),
new TugCP(168,.295241,.674959),
new TugCP(170,.324408,.526189),
new RectVert(.471875,.084375,.569792,-.013542),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.586458,.019792,0)),
new TugCP(1086,.460097,-.059647),
new TugCP(56,.361493,-.419861),
new TugCP(58,.21566,-.579266),
new TugCP(54,.525538,-.233482),
new TugCP(52,.637516,-.156108),
new TugCP(50,.800405,-.138664),
new TugCP(48,.934616,-.116632),
new TugCP(46,1.023713,-.079177),
new RectVert(.09375,.103125,.2125,-.003125),
new TugCP(1078,.175419,.020614),
new ClickButton(insertControlPoint),

new SelNurbsLine(46,77,.507263),
new ToggleField("done"),
new TugCP(112,.696978,-.503409),
new TugCP(110,.773833,-.472584),
new TugCP(108,.827608,-.474114),
new TugCP(118,.320102,-.647123),
new TugCP(149,.311797,-.847402),
new TugCP(116,.448503,-.564547),
new TugCP(147,.430456,-.845062),
new TugCP(165,.086908,-.531818),
new TugCP(167,.253577,-.253063),
new RectVert(.125,.221875,.489583,-.167708),
new TugCP(1148,.447597,-.109647),
new RectVert(.275,-.109375,.36875,-.201042),
new TugCP(1150,.289472,-.183183),
new RectVert(.3875,.1,.4375,-.016667),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.46875,.051042,0)),
new TugCP(1146,.442654,.048677),
new TugCP(258,.929882,.591276),
new TugCP(260,.852986,.496974),
new TugCP(262,.722418,.375534),
new DragViewRot(.640319,-.247682,-.72708,1.401374),
new TugCP(260,.855273,.648215),
new DragViewRot(.549665,-.300478,-.779475,1.273649),
new TugCP(262,.724136,.301598),
new DragViewRot(.108489,.044563,-.993098,1.14627),
new TugCP(230,.608531,.446218),
new TugCP(232,.535858,.195221),
new TugCP(202,.428199,.15475),
new TugCP(200,.439636,.337021),
new TugCP(198,.424783,.578073),

new Section("make neck thiner"),
new ClickButton(setFrontViewOrientation),

new TugCP(350,-.148667,.418396),
new TugCP(200,-.121324,.613476),
new TugCP(202,.064453,.467003),
new TugCP(352,.023716,.378821),
new ClickButton(selectRing),

new SelNurbsLine(120,121,.918836),

new Scale1d(0,-.054921,-.58594),
new DragViewRot(.001946,-.997223,.074448,1.211017),
new ClickButton(selectRing),

new SelNurbsLine(55,56,.350866),
new ClickButton(setFrontViewOrientation),


new Scale1d(0,.075078,-.314424),
new ClickButton(selectRing),

new SelNurbsLine(152,153,.298987),

new Scale1d(0,.067805,-.845847),
new DragViewRot(-.382657,-.744978,.546425,2.228316),
new TugCP(264,.448001,.406169),
new DragViewRot(.096968,-.533371,.840305,.872874),
new TugCP(116,.533704,-.336955),
new DragViewRot(-.370746,.036564,.928014,.802668),
new DragViewRot(.715125,.384173,-.583958,.194629),
new TugCP(222,-.881449,.412374),
new TugCP(192,-.869183,.342799),
new TugCP(342,-.831945,.260361),
new TugCP(340,-.864959,.108088),

new TugCP(338,-.925254,-.122705),
new DragViewRot(.192144,.971998,-.13528,1.078134),
new ClickButton(setHomeMode),


new Section(Complete),
	};
	list+=EVENT_LIST(array0);
}
//new AddCtrlPnt(.418654,.522792),